import os
from sklearn.decomposition import PCA
from sklearn.impute import KNNImputer
from sklearn.preprocessing import StandardScaler
from statsmodels.stats.multitest import multipletests
from scipy.stats import ttest_ind_from_stats
import plotly.graph_objs as go
from plotly.offline import plot
import scipy
import json
import plotly.io as pio
from plotly.offline import iplot
import plotly as py
from matplotlib_venn import venn2, venn3
import matplotlib.pyplot as plt
import matplotlib
import plotly.express as px
from plotly.subplots import make_subplots
from scipy.stats import t
import seaborn as sns
from datetime import datetime, timedelta
import plotly.express as px
from pathlib import Path
import scipy.stats
import math
from select import select
import numpy as np
import pandas as pd
import requests
from requests.auth import HTTPBasicAuth


import scipy.stats
import math
from select import select
import numpy as np
import pandas as pd
import os

from django.conf import settings
from django.contrib.auth.decorators import login_required, permission_required
from file_manager .models import DataAnalysisQueue, SampleRecord, \
    SavedVisualization, VisualizationApp, UserSettings, ProcessingApp
from django.shortcuts import render
import requests
from requests.auth import HTTPBasicAuth


matplotlib.use('SVG')


# app name, must be the same as in the database, file name needs to be same
# as the progam_file_name as in the database
APPNAME = "DDA, DIA and WWA (Visualization)"
SUPPORTED_PROCESS_UUID = VisualizationApp.objects.filter(
    name=APPNAME).first().support_process_apps

# folder to store the methods
APPFOLDER = "media/primary_storage/systemfiles/DDA_DIA_WWA_VISUAL/data/"
# for download link
url_base = "primary_storage/systemfiles/DDA_DIA_WWA_VISUAL/data/"

filepaths = "media/primary_storage/systemfiles/DDA_DIA_WWA_VISUAL/data/"

WRITE_OUTPUT = False
USE_MaxLFQ = False
saved_settings = {} # global variable to store the settings from the saved visualization
#Default plot options in case the user does not provide any

Group_LIST_NAME = ["group1_record", "group2_record",
                   "group3_record", "group4_record",
                   "group5_record"]
GROUP_NAME = ["group1_name", "group2_name", "group3_name",
              "group4_name", "group5_name"]


@ login_required
def view(request):
    """_Main view for the webapp, this is the main function that will be called
    when the user access the webapp_
    Args:
        request (_request_): _request object_
    Returns:    
        _render_: _render the webapp_
    """
    plot_div = None
    plot_div2 = None
    plot_div3 = None
    saved_visualization_settings ={} #settings from the saved visualization
    sample_list = None # grouping of samples
    CSV_link = None
    SVG_link = None
    message = ""
    supported_process = []
    form_data = {}
    sample_list_1 = None # sample list for process 1
    sample_list_3 = None # sample list for process 2
    group_info = None # grouping information, and grouping order with conditions/cell types/modes
    submitted_settings = None # settings submitted by the user
    browser_plot_options = {
    # Protein Identification Bar plot
    "1": 
        {
            "plot_type": "1", # 1 is protein, 2 is peptide
            "mean label": "False",
            "error bar": "ci95", #None, stdev, or ci95
            "X Title": "",
            "Y Title": "Identified Proteins",
            "color": ["#00AF50", "#7fd7a7","#00AF50", "#7fd7a7","#2f5596", "#b4c7e7", "#00AF50", "#7fd7a7","#2f5596", "#b4c7e7", "olive", "cyan", "black","red",
                  "yellow","green","blue","indigo","violet"],
            "width": 600,
            "bar_width": 0.3,
            "height": 800,
            "font": dict(size=16, family="Arial black"),
            "ID mode": "grouped_stacked",#grouped, total, MS2, grouped_stacked, stacked
            "Group By X": "Conditions", #ID_Mode does MS2 vs MBR
            "Group By Color": "Conditions",#ID_Mode does MS2 vs MBR
            "Group By Stack": "ID_Mode",#ID_Mode does MS2 vs MBR
            "help for information only": \
            "Mean label options: True or False." \
            "error bar options: stdev or ci95." \
            "color: the first few colors will be used"
            "ID mode options: total, MS2, stacked." \
        },

    # CV violin plot
    "3": 
        {
            "plot_type": "1", # 1 is protein, 2 is peptide
            "median label": "True", #only works for total and MS2, can be found in CV_summary if you set WRITE_OUTPUT = True
            "box": 'False',
            "show Legend": 'False',
            "X Title": "Conditions (protein)",
            "Y Title": "CV of Abundance (%)",
            "color": ["#7fd7a7","#00AF50", "#7fd7a7","#00AF50", "#b4c7e7","#2f5596",  "#7fd7a7","#00AF50", "#b4c7e7","#2f5596",  "olive", "cyan", "black","red",
                    "yellow","green","blue","indigo","violet"],
            "width": 700,
            "height": 450,
            "bar_width": 0.3,
            "font": dict(size=16, family="Arial black"),
            "ylimits": [0, 100],
            "CV mode": "grouped_stacked",#grouped, total, MS2, grouped_stacked, stacked
            "Group By X": "Conditions", #ID_Mode does MS2 vs MBR
            "Group By Color": "Conditions",#ID_Mode does MS2 vs MBR
            "Group By Stack": "ID_Mode", #ID_Mode does MS2 vs MBR
            "help for information only": \
            "Mean label options: True or False." \
            "color: the first few colors will be used"
            "violinmode: group or overlay." \
        },
    # Abundance PCA plot
    "6": 
        {
            "compare groups": ["WWA K562","WWA Hela"],
            "title": "PCA Analysis",
            "color": ["#2f5596", "#00AF50", "green", "black", "yellow", "purple",
                      "orange", "brown", "pink", "gray", "olive", "cyan"],
            "symbol": ['circle', 'circle', 'circle'],
            "marker_size": 8,
            "width": 700,
            "height": 450,
            "font": dict(size=16, family="Arial black"),
            "ylimits": [],
            "xlimits": [],
            "help for information only": \
            "compare groups: list of two numbers default [0,1] means compare" \
            "color: the first few colors will be used"
            "xlimits: list or tuple of two numbers [0,10]." \
        },

    # Plot all
    "7": 
        {
            "help for information only": "Load all saved setting for three plots, please modify each plot and save the settings individually."
        },

    }   
    sopported_UUID_list = SUPPORTED_PROCESS_UUID.split(",")
    for uuid in sopported_UUID_list:
        supported_process.append(
            ProcessingApp.objects.filter(UUID=uuid.strip()).first())

    supported_analysis = DataAnalysisQueue.objects.filter(
        run_status=True,
        processing_app__in=supported_process).order_by('-pk')
    
    #get the last saved visualization for current app
    current_saved_visualization = SavedVisualization.objects.filter(
        visualization_app=VisualizationApp.objects.filter(
            name=APPNAME).first()).order_by('-pk')
    
    if request.method == 'POST':
        for item in request.POST: #save the form data to be display after sumbit
            form_data[item] = request.POST[item]
        selected_visualization = SavedVisualization.objects.filter(
            pk=request.POST.get("Select_exist_analysis")).first()
        saved_visualization_settings = selected_visualization.settings

        submitted_settings = {
            "new_analysis_name": request.POST.get('new_analysis_name'),
            "group1_name": request.POST.get('group1_name'),
            "group2_name": request.POST.get('group2_name'),
            "group3_name": request.POST.get('group3_name'),
            "group4_name": request.POST.get('group4_name'),
            "group5_name": request.POST.get('group5_name'),
            "group1_record": request.POST.getlist('group1_record'),
            "group2_record": request.POST.getlist('group2_record'),
            "group3_record": request.POST.getlist('group3_record'),
            "group4_record": request.POST.getlist('group4_record'),
            "group5_record": request.POST.getlist('group5_record'),
            "plot_type": request.POST.get('plot_type'),
            "group1_filterin": request.POST.get('group1_filterin'),
            "group2_filterin": request.POST.get('group2_filterin'),
            "group3_filterin": request.POST.get('group3_filterin'),
            "group4_filterin": request.POST.get('group4_filterin'),
            "group5_filterin": request.POST.get('group5_filterin'),
            "plot_options":  request.POST.get('plot_options'),
        }



        # if load from saved visualization use saved data source, otherwise
        # use the data source from form
        data_process_queue_1 = saved_visualization_settings["group1_queue"] #PD data source
        data_process_queue_2 = saved_visualization_settings["group2_queue"] #DIA_without_lib data source
        data_process_queue_3 = saved_visualization_settings["group3_queue"] #PD_with_lib data source

        if 'delete_saved_visualization' not in request.POST:
            # will load data unless deleteding
            #Load all input files from data process queues
            sample_list_1 = get_run_name(data_process_queue_1).to_dict()
            sample_list_3 = get_run_name(data_process_queue_3).to_dict()

            # convert the list of sample id to list of sample name and id to
            # put in the group select box
            for item in Group_LIST_NAME:
                if item in ["group2_record","group3_record"]:
                    sample_list = sample_list_3
                else:
                    sample_list = sample_list_1
                if submitted_settings[item] != []:
                    submitted_settings[item] = \
                        list(map(lambda x: {
                            "value": x, "option": sample_list[int(x)]},
                            submitted_settings[item]))

        if 'start_new_analysis' in request.POST:
            # create new SavedVisualization object:
            formdata = {
                "visualization_app":
                    VisualizationApp.objects.filter(name=APPNAME).first(),
                "visual_creator": request.user,
                "visualization_name": request.POST.get('new_analysis_name'),
                "settings": submitted_settings,
            }
            new_saved = SavedVisualization.objects.create(**formdata)
            new_saved.save()
            form_data["Select_exist_analysis"] = new_saved.pk

        elif 'delete_saved_visualization' in request.POST:
            # delete SavedVisualization :
            if request.user == selected_visualization.visual_creator:
                SavedVisualization.objects.filter(
                    pk=selected_visualization.pk).delete()
            else:
                message = "You are not allowed to delete this analysis!"

        elif 'load_saved_visualization' in request.POST:
            # load SavedVisualization :
            for item in saved_visualization_settings:
                form_data[item] = saved_visualization_settings[item]
            form_data["new_analysis_name"] = selected_visualization.visualization_name
            # if settings["plot_options_ID"] exists, load the plot options
            if 'plot_options_ID' in saved_visualization_settings:
                browser_plot_options["1"] = saved_visualization_settings['plot_options_ID']

                #PLOT_OPTIONS["1"] = json.loads(settings['plot_options_ID'].replace("'", '"'))
            if 'plot_options_CV' in saved_visualization_settings:
                #PLOT_OPTIONS["3"] = json.loads(settings['plot_options_CV'].replace("'", '"'))
                browser_plot_options["3"] = saved_visualization_settings['plot_options_CV']

            if 'plot_options_PCA' in saved_visualization_settings:
                #PLOT_OPTIONS["7"] = json.loads(settings['plot_options_PCA'].replace("'", '"'))
                browser_plot_options["7"] = saved_visualization_settings['plot_options_PCA']

        elif 'save_plot' in request.POST and \
                request.POST.get('new_analysis_name') != "":
            #save setting from loaded settings into sumbitted settings
            for item in ["plot_options_ID","plot_options_CV","plot_options_PCA","group1_queue","group2_queue","group3_queue"]:
                if item in saved_visualization_settings:
                    submitted_settings[item] = saved_visualization_settings[item]
            # get the data from the form plot_options to save in the settings
            plot_type= request.POST.get('plot_type')

            if plot_type  == "1": # ID bar plot
                submitted_settings["plot_options_ID"]=  json.loads(request.POST.get(
                    "plot_options").replace("'", '"'))
                # get the data from the form plot_options
                browser_plot_options["1"] = json.loads(request.POST.get(
                    "plot_options").replace("'", '"'))
                # read the data
                
                x = read_files(queue_ids=[ submitted_settings["group1_queue"], submitted_settings["group2_queue"], submitted_settings["group3_queue"]])
                data_obj = outer_join_data_objects(x)
                group_info = create_groups(submitted_settings)
                plot_div, CSV_link, SVG_link = ID_plots(
                                    data_obj,
                                    browser_plot_options["1"],
                                    group_info,
                                    request.user.username)
            elif plot_type in ["3"]:  # CV Violin plot
                submitted_settings["plot_options_CV"]=  json.loads(request.POST.get(
                    "plot_options").replace("'", '"'))
                # get the data from the form plot_options
                browser_plot_options["3"] = json.loads(request.POST.get(
                    "plot_options").replace("'", '"'))
                # read the data
                
                x = read_files(queue_ids=[ submitted_settings["group1_queue"], submitted_settings["group2_queue"], submitted_settings["group3_queue"]])
                data_obj = outer_join_data_objects(x)
                group_info = create_groups(submitted_settings)
                
                plot_div2, CSV_link, SVG_link = CV_plots(
                    data_obj,
                    browser_plot_options["3"],
                    group_info,
                    request.user.username)
            elif plot_type in ["6"]:  # PCA plot
                submitted_settings["plot_options_PCA"]=  json.loads(request.POST.get(
                    "plot_options").replace("'", '"'))
                # get the data from the form plot_options
                browser_plot_options["6"] = json.loads(request.POST.get(
                    "plot_options").replace("'", '"'))
                # read the data
                
                x = read_files(queue_ids=[ submitted_settings["group1_queue"], submitted_settings["group2_queue"], submitted_settings["group3_queue"]])
                data_obj = outer_join_data_objects(x)
                group_info = create_groups(submitted_settings)                
                
                plot_div3, CSV_link, SVG_link = PCA_plots(
                    data_obj,
                    browser_plot_options["6"],
                    group_info,
                    request.user.username)


               
            elif request.POST.get('plot_type') == "7":
                # get the data from the form plot_options
                if 'plot_options_ID' in saved_visualization_settings:
                    browser_plot_options["1"]  =  saved_visualization_settings["plot_options_ID"]
                else:
                    browser_plot_options["1"]  =  browser_plot_options["1"]
                


                # read the data
                
                x = read_files(queue_ids=[ submitted_settings["group1_queue"], submitted_settings["group2_queue"], submitted_settings["group3_queue"]])
                data_obj = outer_join_data_objects(x)
                group_info = create_groups(submitted_settings)
                plot_div, CSV_link, SVG_link = ID_plots(
                                    data_obj,
                                    browser_plot_options["1"] ,
                                    group_info,
                                    request.user.username)
                



                if 'plot_options_CV' in saved_visualization_settings:
                    browser_plot_options["3"] =  saved_visualization_settings["plot_options_CV"]
                else:
                    browser_plot_options["3"] = browser_plot_options["3"]
                

                # get the data from the form plot_options
                x = read_files(queue_ids=[ submitted_settings["group1_queue"], submitted_settings["group2_queue"], submitted_settings["group3_queue"]])
                data_obj = outer_join_data_objects(x)
                group_info = create_groups(submitted_settings)
                
                plot_div2, CSV_link, SVG_link = CV_plots(
                    data_obj,
                    browser_plot_options["3"],
                    group_info,
                    request.user.username)
                
                # get the data from the form plot_options
                if 'plot_options_PCA' in saved_visualization_settings:
                    browser_plot_options["6"] =  saved_visualization_settings["plot_options_PCA"]
                else:
                    browser_plot_options["6"] =  browser_plot_options["6"]
                # read the data
                
                x = read_files(queue_ids=[ submitted_settings["group1_queue"], submitted_settings["group2_queue"], submitted_settings["group3_queue"]])
                data_obj = outer_join_data_objects(x)
                group_info = create_groups(submitted_settings)                
                
                plot_div3, CSV_link, SVG_link = PCA_plots(
                    data_obj,
                    browser_plot_options["6"],
                    group_info,
                    request.user.username)

            # save settings and plot if new_analysis_name is not empty:
            selected_visualization.settings = submitted_settings
            selected_visualization.save()
            saved_visualization_settings = submitted_settings

    
    for key,item in browser_plot_options.items():
        browser_plot_options[key] =json.dumps(browser_plot_options[key])
    if plot_div is not None:
        plot_div = plot(plot_div, output_type="div")
    elif plot_div2 is not None:
    # if no plot_div, use plot_div2, due to plot_div2 doesn't work well without plot1 along
        plot_div = plot(plot_div2, output_type="div")
        plot_div2 = None
    if plot_div2 is not None:
        plot_div2 = plot(plot_div2, output_type="div")    
    if plot_div3 is not None:
        plot_div3 = plot(plot_div3, output_type="div")  
    args = {
        "SampleRecord":
            SampleRecord.objects.all().order_by('-pk'),
        "SavedVisualization": current_saved_visualization,
        "formdata": form_data,  # data before post or loaded from database
        # "message": message,
        "plot_div": plot_div,
        "plot_div2": plot_div2,
        "plot_div3": plot_div3,
        "saved_settings": saved_visualization_settings,
        "DataAnalysisQueue": supported_analysis,
        "javascript_plot_options": json.dumps(browser_plot_options),
        "sample_list_1": sample_list_1,
        "sample_list_3": sample_list_3,
        "message": message,
        "SVG_link": SVG_link,
        "csv_link": CSV_link,


    }

    return render(request,
                  'filemanager/WWA_DDA_DIA_visual.html', args)



def get_run_name(queue_id):
    """_Get the run name/sample list from the result files, only
    used for webapp for populate dropdown list_
    Args:
        queue_id (_int_): _task id from the process queue_
    Returns:
        _type_: _pandas data serial contains experiment list_
        0              sample1
        1              sample2
        2              sample3
    """
    if not queue_id:
        return None
    # get processing name
    process_app = DataAnalysisQueue.objects.filter(
        pk=queue_id).first().processing_app.name
    # fragpipe results
    if "FragPipe" in process_app:
        peptide_file = DataAnalysisQueue.objects.filter(
            pk=queue_id).first().output_file_2
        peptide = pd.read_table(peptide_file)
        #
        # get experiment names from columns names containning " MaxLFQ Intensity"
        run_names = [
            col for col in peptide.columns if " MaxLFQ Intensity" in col]
        # remove " MaxLFQ Intensity" from the experiment names
        run_names = [name.replace(" MaxLFQ Intensity", "")
                     for name in run_names]
        # create a pandas series to store the experiment names
        run_names = pd.Series(run_names)
    elif "PD" in process_app:
        inpufile_5 = DataAnalysisQueue.objects.filter(
            pk=queue_id).first().output_file_5
        meta_table = pd.read_table(inpufile_5)
        # filter out the rows with empty File ID column
        meta_table = meta_table[meta_table['File ID'].notna()]
        # Replace single backslashes with forward slashes in the 'file_paths' column
        meta_table['File Name'] = meta_table['File Name'].str.replace(
            '\\', '/', regex=False)
        # Apply a lambda function to extract file names without extensions
        meta_table['file_names'] = meta_table['File Name'].apply(
            lambda x: os.path.splitext(os.path.basename(x))[0])
        run_names = meta_table['file_names']
    elif "DIA" in process_app:
        inpufile_5 = DataAnalysisQueue.objects.filter(
            pk=queue_id).first().output_file_5
        # Read the file line by line into a list
        with open(os.path.join(settings.MEDIA_ROOT, inpufile_5.name), 'r') as file:
            lines = file.readlines()

        # Create a DataFrame from the list
        df = pd.DataFrame(lines, columns=["line"])

        # Extract the file paths from each line
        df['file_path'] = df['line'].str.split('--f ').str[1].str.strip()

        # Extract the file names without extension
        df['file_name'] = df['file_path'].str.split('\\').str[-1].str.split('.').str[0]
        run_names = df['file_name']


    else:
        run_names = pd.Series()

    return run_names

# Read the data


def read_file(queue_id=None, queue_info= None, processor_info = None,
               input1=None, input2=None,input3=None, input4=None, input5=None,
            process_app = None, file_id = 1):
    """_Read data from data manager API or through local files or read directly
    in the webapp_
    Args:
        queue_id (_int_): _processing queue id_
        queue_info (_dict_): _queue info from the API_
        processor_info (_dict_): _processor info from the API_        
        input1 (_str_): _input file 1_ 
        input2 (_str_): _input file 2_
        input3 (_str_): _input file 3_
        input4 (_str_): _input file 4_
        input5 (_str_): _input file 5_
        process_app (_str_): _process app name_
    Returns:
        _dict_: _dictionary containing data all data        
    """

    """ Input files are as followws
    App       Input file
              1                         2                       3         4         5
    PD        _Proteins                 _PeptideGroups                              _InputFiles
    Fragpipe  combined_protein          combined_peptide
    DIANN     diann-output.pg_matrix    diann-output.pr_matrix  protein   peptide   filelist_diann.txt
    """

    min_unique_peptides = 1

    #getting files from data system
        # getting files from data system (webapp)
    if queue_id is not None and processor_info is None:
        # Method 1 pull data directly (used by the webapp)
        process_app = DataAnalysisQueue.objects.filter(
            pk=queue_id).first().processing_app.name
        input1= DataAnalysisQueue.objects.filter(
            pk=queue_id).first().output_file_1
        input2= DataAnalysisQueue.objects.filter(
            pk=queue_id).first().output_file_2  
        input3= DataAnalysisQueue.objects.filter(
            pk=queue_id).first().output_file_3
        input4= DataAnalysisQueue.objects.filter(
            pk=queue_id).first().output_file_4  
        input5= DataAnalysisQueue.objects.filter(
            pk=queue_id).first().output_file_5
    elif queue_info is not None and processor_info is not None:
    # Method 2 pull data from the data system (used by jupyter notebook)
        process_app = processor_info["name"]
        input1= queue_info["output_file_1"]
        input2= queue_info["output_file_2"]  
        input3= queue_info["output_file_3"]
        input4= queue_info["output_file_4"]  
        input5= queue_info["output_file_5"]
    # method 3 feed data directly (through local file paths)
    else:
        analysis_file = input1

    if "FragPipe" in process_app:     # fragpipe results
        # read data
        peptide_table = pd.read_table(input2,low_memory=False)
        protein_table = pd.read_table(input1,low_memory=False)

        # filter Contaminant
        peptide_table= peptide_table[~peptide_table[
            'Mapped Proteins'].str.contains(
            "contam_sp", na=False)]
        protein_table= protein_table[~protein_table['Protein'].str.contains(
            "contam_sp", na=False)].query(
            "`Combined Total Peptides` >= @min_unique_peptides")
        # get experiment names from columns names containning "Intensity"
        # or " MaxLFQ Intensity" if MaxLFQ is used

        if USE_MaxLFQ:
            column_tail = " MaxLFQ Intensity"
            intensity_cols = protein_table.columns[
                protein_table.columns.str.contains(column_tail)].tolist() #These should be the same for MS2
        else:
            column_tail = " Intensity" #this includes MaxLFQ Intensity
            cols = protein_table.columns
            intensity_cols =  protein_table.columns[( \
                cols.str.contains(" Intensity")) & \
                (~cols.str.contains(" MaxLFQ Intensity"))]
        prot_ID_cols = protein_table.columns[(cols.str.contains(" Unique Spectral Count")) & ~(cols == "Combined Unique Spectral Count")] #so we remove MaxLFQ Intensity here
        cols = peptide_table.columns
        pep_ID_cols = peptide_table.columns[(cols.str.contains(" Spectral Count"))] #so we remove MaxLFQ Intensity here
        #get the column names of protein_table that contain "Intensity" but not " MaxLFQ"
        
        # ALL
        ## Proteins abundance table
        protein_table.rename(columns={'Protein ID': 'Accession'},inplace=True)
        all_abundance_cols = intensity_cols.append(pd.Index(['Accession']))
        prot_abundance = protein_table.loc[:, all_abundance_cols]
        ## Peptide abundance table
        peptide_table.rename(columns={'Peptide Sequence': 'Annotated Sequence'}, inplace=True)
        all_abundance_cols = intensity_cols.append(pd.Index(['Annotated Sequence']))
        pep_abundance = peptide_table.loc[:, all_abundance_cols]

        # Proteins ID table
        all_ID_cols = prot_ID_cols.append(pd.Index(['Accession']))
        prot_ID_MS2 = protein_table.loc[:, all_ID_cols]
        
        # Proteins ID table
        all_ID_cols = pep_ID_cols.append(pd.Index(['Annotated Sequence']))
        pep_ID_MS2 = peptide_table.loc[:, all_ID_cols]


        # remove "Spectral Count", " MaxLFQ Intensity" or " Intensity" from names
        run_name_list = [name.replace(column_tail, "")
                            for name in intensity_cols]
        
        run_name_list = pd.DataFrame({"Run Names": run_name_list})
        run_name_list['Run Identifier'] = run_name_list.index.to_series().apply(lambda x: str(file_id) + "-" + str(x))

        prot_abundance = prot_abundance.rename(columns={
            col: col.replace(column_tail, "") for col in
              prot_abundance.columns if column_tail in col})

        pep_abundance = pep_abundance.rename(columns={
            col: col.replace(column_tail, "") for col in
              pep_abundance.columns if column_tail in col})
        
        prot_ID_MS2 = prot_ID_MS2.rename(columns={
            col: col.replace(" Unique Spectral Count", "") for col in
              prot_ID_MS2.columns if " Unique Spectral Count" in col})

        pep_ID_MS2 = pep_ID_MS2.rename(columns={
            col: col.replace(" Spectral Count", "") for col in
              pep_ID_MS2.columns if " Spectral Count" in col})

        # print(pep_ID_MS2.columns)

        for item in [prot_abundance,pep_abundance,pep_ID_MS2,prot_ID_MS2]:
            # Generate a new column name mapping using the function
            fileid_mapping = generate_column_to_name_mapping(item.columns, dict(zip(run_name_list["Run Names"],run_name_list["Run Identifier"])))
            item.rename(columns = fileid_mapping,inplace=True)
        

        # get ID matrix tables
        prot_ID = prot_abundance.copy()
        cols = [col for col in prot_ID.columns if col != 'Accession']
        for col in cols:
            if prot_ID[col].dtype != 'object': # Check if not a string column
                prot_ID[col].replace(0, np.nan, inplace=True)
                # Replace all numerical values to ID
                prot_ID[col] = prot_ID[col].astype(str).str.replace("\d+\.\d+", "ID", regex=True)
        pep_ID = pep_abundance.copy()
        cols = [col for col in pep_ID.columns if col != 'Annotated Sequence	']
        for col in cols:
            if pep_ID[col].dtype != 'object': # Check if not a string column
                pep_ID[col].replace(0, np.nan, inplace=True)
                # Replace all numerical values to ID
                pep_ID[col] = pep_ID[col].astype(str).str.replace("\d+\.\d+", "ID", regex=True)
        #Rename protein numbers
        
        cols = [col for col in prot_ID_MS2.columns if col != 'Accession']
        for col in cols:
            if prot_ID_MS2[col].dtype != 'object': # Check if not a string column
                prot_ID_MS2[col].replace(0, np.nan, inplace=True)
                # Replace all numerical values to ID
                prot_ID_MS2[col] = prot_ID_MS2[col].astype(str).str.replace("\d+\.\d+", "MS2", regex=True)
        cols = [col for col in pep_ID_MS2.columns if col != 'Annotated Sequence	']
        for col in cols:
            if pep_ID_MS2[col].dtype != 'object': # Check if not a string column
                pep_ID_MS2[col].replace(0, np.nan, inplace=True)
                # Replace all numerical values to ID
                pep_ID_MS2[col] = pep_ID_MS2[col].astype(str).str.replace("\d+\.\d+", "MS2", regex=True)

        # print(run_name_list)
        pep_ID = combine_IDs(pep_ID, pep_ID_MS2)
        prot_ID = combine_IDs(prot_ID, prot_ID_MS2)

        prot_other_info = protein_table.loc[
            :, ~protein_table.columns.str.contains('Intensity')]
        prot_other_info["Source_File"] = input1
        pep_other_info = peptide_table.loc[
            :, ~peptide_table.columns.str.contains('Intensity')]
        pep_other_info["Source_File"] = input2


    elif "DIA" in process_app:
        # read in DIANN output files
        peptide_table = pd.read_table(input2,low_memory=False)
        protein_table = pd.read_table(input1,low_memory=False)
        protein_table_MS2 = pd.read_table(input3,low_memory=False)
        peptide_table_MS2 = pd.read_table(input4,low_memory=False)
        prot_other_info = pd.DataFrame({"Protein": protein_table["Protein.Ids"], "Protein.Group": protein_table["Protein.Group"]})
        pep_other_info = pd.DataFrame({"Mapped Proteins": peptide_table["Protein.Group"], "Modified.Sequence": peptide_table["Modified.Sequence"]})

        prot_other_info["Source_File"] = "None"
        pep_other_info["Source_File"] = "None"

        # meta_table = pd.read_csv(input5, sep=' ', header=None, names=["File Name"])
        # filter Contaminant
        protein_table= protein_table[~protein_table['Protein.Group'].str.contains(
            "contam_sp", na=False)]
        peptide_table= peptide_table[~peptide_table['Protein.Group'].str.contains(
            "contam_sp", na=False)]
        protein_table_MS2= protein_table_MS2[~protein_table_MS2['Protein.Group'].str.contains(
            "contam_sp", na=False)]
        peptide_table_MS2= peptide_table_MS2[~peptide_table_MS2['Protein.Group'].str.contains(
            "contam_sp", na=False)]
        prot_other_info= prot_other_info[~prot_other_info['Protein'].str.contains(
            "contam_sp", na=False)]
        pep_other_info= pep_other_info[~pep_other_info['Mapped Proteins'].str.contains(
            "contam_sp", na=False)]
        
        prot_other_info.rename(columns={'Protein': 'Accession'}, inplace=True)
        pep_other_info.rename(columns={'Modified.Sequence': 'Annotated Sequence'}, inplace=True)
        # Replace backslashes with forward slashes if data comes from Windows
        # meta_table['File Name'] = meta_table['File Name'].str.replace('\\', '/', regex=False)
        # # Apply a lambda function to extract file names without extensions
        # meta_table['File Name'] = meta_table['File Name'].apply(lambda x: os.path.splitext(os.path.basename(x))[0])
        # run_name_list = meta_table['File Name'].tolist()
        # run_name_list = pd.DataFrame({"Run Names": run_name_list})
        # run_name_list['Run Identifier'] = run_name_list.index.to_series().apply(lambda x: str(file_id) + "-" + str(x))


        # Get the file names from the meta table
        protein_path_cols = protein_table_MS2.filter(regex='\\\\|Protein.Ids').columns
        #protein_path_cols = pd.Index([path.replace('\\', '/') for path in protein_path_cols]) # change to linux path

        ## Proteins
        prot_abundance = protein_table.loc[:, protein_path_cols]
        prot_abundance_MS2 = protein_table_MS2.loc[:, protein_path_cols]
        # Rename Columns to remove file path
        file_path_cols = protein_table.filter(regex='\\\\').columns
        
        file_path_cols = pd.Index([path.replace('\\', '/') for path in file_path_cols]) # handle windows path
        prot_abundance.columns = [path.replace('\\', '/') for path in prot_abundance.columns] #handle windows path
        prot_abundance_MS2.columns = [path.replace('\\', '/') for path in prot_abundance_MS2.columns] # handle windows path



        prot_abundance.columns = [os.path.splitext(os.path.basename(x))[0] if x in file_path_cols else x for x in prot_abundance.columns]

        prot_abundance = prot_abundance.rename(columns={'Protein.Ids': 'Accession'})
        prot_abundance["Accession"] =  prot_abundance["Accession"].str.replace(";.*","",regex = True)
        prot_abundance_MS2.columns = [os.path.splitext(os.path.basename(x))[0] if x in file_path_cols else x for x in prot_abundance_MS2.columns]

        prot_abundance_MS2 = prot_abundance_MS2.rename(columns={'Protein.Ids': 'Accession'})   
        prot_abundance_MS2["Accession"] =  prot_abundance_MS2["Accession"].str.replace(";.*","",regex = True)

        ## Peptides
        peptide_path_cols = peptide_table_MS2.filter(regex='\\\\|Modified.Sequence').columns
        pep_abundance = peptide_table.loc[:, peptide_path_cols]
        pep_abundance_MS2 = peptide_table_MS2.loc[:, peptide_path_cols]
        # Rename Columns to remove file path
        file_path_cols = peptide_table.filter(regex='\\\\').columns
        # in case OS system is linux
        file_path_cols = pd.Index([path.replace('\\', '/') for path in file_path_cols]) # change to linux path

        
        pep_abundance.columns = [os.path.splitext(os.path.basename(x))[0] if x in file_path_cols else x for x in pep_abundance.columns]
        pep_abundance = pep_abundance.rename(columns={'Modified.Sequence': 'Annotated Sequence'})
        pep_abundance_MS2.columns = [os.path.splitext(os.path.basename(x))[0] if x in file_path_cols else x for x in pep_abundance_MS2.columns]
        pep_abundance_MS2 = pep_abundance_MS2.rename(columns={'Modified.Sequence': 'Annotated Sequence'})

        run_name_list = pd.DataFrame(data={"Run Names": [os.path.splitext(os.path.basename(x))[0] for x in file_path_cols]})
        run_name_list['Run Identifier'] = run_name_list.index.to_series().apply(lambda x: str(file_id) + "-" + str(x))
       
        for item in [prot_abundance,pep_abundance,prot_abundance_MS2,pep_abundance_MS2]:
            #print(item.columns, dict(zip(run_name_list["Run Names"],run_name_list["Run Identifier"])))
            # Generate a new column name mapping using the function
            fileid_mapping = generate_column_to_name_mapping(item.columns, dict(zip(run_name_list["Run Names"],run_name_list["Run Identifier"])))
            item.rename(columns = fileid_mapping,inplace=True)


        #convert to str for IDs matrix
        pep_ID = pep_abundance.copy()
        cols = [col for col in pep_ID.columns if col != 'Accession']
        for col in cols:
            if pep_ID[col].dtype != 'object': # Check if not a string column
                pep_ID[col].replace(0, np.nan, inplace=True)
                # Replace all numerical values to ID
                pep_ID[col] = pep_ID[col].astype(str).str.replace("\d+\.\d+", "ID", regex=True)
        pep_ID_MS2 = pep_abundance_MS2.copy()
        cols = [col for col in pep_ID_MS2.columns if col != 'Accession']
        for col in cols:
            if pep_ID_MS2[col].dtype != 'object': # Check if not a string column
                pep_ID_MS2[col].replace(0, np.nan, inplace=True)
                # Replace all numerical values to ID
                pep_ID_MS2[col] = pep_ID_MS2[col].astype(str).str.replace("\d+\.\d+", "MS2", regex=True)
        prot_ID = prot_abundance.copy()
        cols = [col for col in prot_ID.columns if col != 'Accession']
        for col in cols:
            if prot_ID[col].dtype != 'object': # Check if not a string column
                prot_ID[col].replace(0, np.nan, inplace=True)
                # Replace all numerical values to ID
                prot_ID[col] = prot_ID[col].astype(str).str.replace("\d+\.\d+", "ID", regex=True)
        prot_ID_MS2 = prot_abundance_MS2.copy()
        cols = [col for col in prot_ID_MS2.columns if col != 'Accession']
        for col in cols:
            if prot_ID_MS2[col].dtype != 'object': # Check if not a string column
                prot_ID_MS2[col].replace(0, np.nan, inplace=True)
                # Replace all numerical values to ID
                prot_ID_MS2[col] = prot_ID_MS2[col].astype(str).str.replace("\d+\.\d+", "MS2", regex=True)
        pep_ID = combine_IDs(pep_ID, pep_ID_MS2)
        prot_ID = combine_IDs(prot_ID, prot_ID_MS2)       

    elif "PD" in process_app:
        peptide_table = pd.read_table(input2,low_memory=False)
        protein_table = pd.read_table(input1,low_memory=False)
        
        # filter Contaminant
        protein_table= protein_table[(protein_table[
            "Protein FDR Confidence: Combined"] == "High") &
                        ((protein_table["Master"] == "IsMasterProtein") | 
                         (protein_table["Master"] == "Master")) & 
                        (protein_table["Contaminant"] == False)]

        protein_table.rename(
            columns={'# Unique Peptides': 'number of peptides'}, inplace=True)
        protein_table=protein_table.query(
            "`number of peptides` >= @min_unique_peptides")
        peptide_table= peptide_table[(peptide_table[
            'Contaminant'] == False) & (peptide_table["Confidence"]== "High")]

        meta_table = pd.read_table(input5,low_memory=False)
        #filter rows in meta table on File ID column if it is NaN
        meta_table = meta_table[meta_table['File ID'].notna()]

        # Replace single backslashes with forward slashes in the 'file_paths' column
        meta_table['File Name'] = meta_table['File Name'].str.replace('\\', '/', regex=False)
        # Apply a lambda function to extract file names without extensions
        meta_table['file_names'] = meta_table['File Name'].apply(lambda x: os.path.splitext(os.path.basename(x))[0])
        file_path_name_dict = dict(zip(meta_table['File ID'], meta_table['file_names']))
        run_name_list = pd.DataFrame({"Run Names": file_path_name_dict.values()})
        run_name_list['Run Identifier'] = run_name_list.index.to_series().apply(lambda x: str(file_id) + "-" + str(x))
        
        #format the read in table into three different tables: abundance, id and other_info
        prot_abundance = protein_table.filter(regex='Abundance:|Accession')
        prot_ID = protein_table.filter(regex='Found in Sample:|Accession')
        prot_other_info = protein_table.loc[:, ~protein_table.columns.str.contains('Found in Sample:|Abundance:')]
        

        pep_abundance = peptide_table.filter(regex='Abundance:|Annotated Sequence')
        pep_ID = peptide_table.filter(regex='Found in Sample:|Annotated Sequence')
        pep_other_info = peptide_table.loc[:, ~peptide_table.columns.str.contains('Found in Sample:|Abundance:')]

        prot_other_info["Source_File"] = input1
        pep_other_info["Source_File"] = input2

        #change column names to file/run names to our fileID

        new_dict = {"Abundance: " + key + ":": value for key, value in file_path_name_dict.items()}
        for item in [prot_abundance,pep_abundance]:
            # Generate a new column name mapping using the function
            column_name_mapping = generate_column_from_name_mapping(item.columns, new_dict)
            #TODO solving  A value is trying to be set on a copy of a slice from a DataFrame
            
            item.rename(columns = column_name_mapping, inplace = True)
            #use generate_column_to_name_mapping function because we don't want partial matches as in QC_HeLa.raw and QC_HeLa_20230727235101.raw
            fileid_mapping = generate_column_to_name_mapping(item.columns, dict(zip(run_name_list["Run Names"],run_name_list["Run Identifier"])))
            item.rename(columns = fileid_mapping,inplace=True)
        

        new_dict = {"Found in Sample: " + key + ":": value for key, value in file_path_name_dict.items()}
        for item in [pep_ID,prot_ID]:
            # Generate a new column name mapping using the function
            column_name_mapping = generate_column_from_name_mapping(item.columns, new_dict)

            item.rename(columns = column_name_mapping, inplace = True)
            #use generate_column_to_name_mapping function because we don't want partial matches
            fileid_mapping = generate_column_to_name_mapping(item.columns, dict(zip(run_name_list["Run Names"],run_name_list["Run Identifier"])))

            item.rename(columns = fileid_mapping,inplace=True)

        # replace "High" to MS2 "Peak Found" to MBR, the rest become np.NaN
        replacements = {'High': 'MS2', 'Peak Found': 'MBR', "Medium": np.NaN, "Low": np.NaN, "Not Found": np.NaN}
        for column in run_name_list["Run Identifier"]:
            if column in pep_ID.columns:
                pep_ID[column] = pep_ID[column].replace(to_replace=replacements)
    
            if column in prot_ID.columns:
                prot_ID[column] = prot_ID[column].replace(to_replace=replacements)
    
    # get ID summary by parsing ID Matrix
    protein_ID_summary = sumIDs(prot_ID)
    peptide_ID_summary = sumIDs(pep_ID)
    

    #sets the processing app in run_name_list
    run_name_list["Processing App"] = process_app
    run_name_list["Analysis Name"] = analysis_file


    return {'run_metadata': run_name_list,
            'protein_other_info': prot_other_info,
            'peptide_other_info': pep_other_info,
            'protein_abundance': prot_abundance,
            'protein_ID_matrix': prot_ID,
            'protein_ID_Summary': protein_ID_summary,
            'peptide_abundance': pep_abundance,
            'peptide_ID_matrix': pep_ID,
            'peptide_ID_Summary': peptide_ID_summary,

            }  

def read_files(queue_ids = None, queue_info = None, processor_info = None, grouped_input_files = []):
    '''
    Creates a list of data objects
    
    Input
    grouped_input_files
    [
        #File 0
    {input1:
    input2:
    input3:   
    input4:
    input5:
    process_app:
    },
        #File 1
    {input1:
    input2:
    input3:   
    input4:
    input5:
    process_app:
    },
    ...
    ]
    '''


    data_objects = []

    i = 0
    if queue_ids is not None: #used for webapp with queue_ids
        process1 = DataAnalysisQueue.objects.filter(
            pk=int(queue_ids[0])).first()
        process2 = DataAnalysisQueue.objects.filter(
            pk=int(queue_ids[1])).first()
        process3 = DataAnalysisQueue.objects.filter(
            pk=int(queue_ids[2])).first()        
        filelist = [
            # PD_BB
             {"input1":os.path.join(settings.MEDIA_ROOT,process1.output_file_1.name),
             "input2":os.path.join(settings.MEDIA_ROOT,process1.output_file_2.name),
             "input3":"",
             "input4":"",
             "input5":os.path.join(settings.MEDIA_ROOT, process1.output_file_5.name),
             "process_app": process1.processing_app.name},
            # DIA NN
             {"input1":os.path.join(settings.MEDIA_ROOT, process3.output_file_1.name) ,
             "input2":os.path.join(settings.MEDIA_ROOT,process3.output_file_2.name),
             "input3":os.path.join(settings.MEDIA_ROOT,process2.output_file_1.name),
             "input4":os.path.join(settings.MEDIA_ROOT,process2.output_file_2.name),
             "input5":os.path.join(settings.MEDIA_ROOT,process2.output_file_5.name),
             "process_app":process2.processing_app.name},
          
            ]
    for eachGroup in filelist:
        process_app = eachGroup["process_app"]
        input1= eachGroup["input1"]
        input2= eachGroup["input2"] 
        input3= eachGroup["input3"]
        input4= eachGroup["input4"]
        input5= eachGroup["input5"]

        current_data_object = read_file(input1=input1,input2=input2,
                                        input3=input3,input4 = input4,
                                        input5=input5, process_app=process_app,file_id = i)
        data_objects.append(current_data_object)
        
        i = i + 1


    return data_objects

def create_groups(settings):
    """_Create groups from the settings_
    """
    group_info = {}
    for record, name in zip(Group_LIST_NAME, GROUP_NAME):
        if "DIA" in settings[name]:
            acuisition_mode = "DIA"
        elif "DDA" in settings[name]:
            acuisition_mode = "DDA"
        elif "DDA" in settings[name]:
            acuisition_mode = "WWA"
        if "Hela" in settings[name]:
            cell_type = "Hela"
        elif "K562" in settings[name]:
            cell_type = "K562"
        
        group_info[settings[name]] = {
        'Cell Type':cell_type,
        'Acquisition Mode': acuisition_mode,
        'records': [item['option'] for item in settings[record]],
        }
    group_info["Order@Conditions"] = ['DDA Hela','DIA Hela','DIA K562','WWA Hela','WWA K562']
    group_info['Order@Cell Type'] = ['HeLa', 'K562']
    group_info['Order@Acquisition Mode'] = ['DDA', 'DIA', 'WWA']
    return group_info

def combine_IDs(all_matrix, MS2_matrix):
    # make IDs into MBR
    if "Annotated Sequence" in all_matrix.columns:
        name = "Annotated Sequence"
    elif "Accession" in all_matrix.columns:  
        name = "Accession"
    id_cols = all_matrix.columns.tolist()
    id_cols.remove(name)
    
    
    # for eachColumn in id_cols:
    #     if len(all_matrix[(all_matrix[name].isin(MS2_matrix[name]) & (MS2_matrix[eachColumn] == "MS2"))]) > 0:
    #         all_matrix.loc[(all_matrix[name].isin(MS2_matrix[name]) & (MS2_matrix[eachColumn] == "MS2")), [eachColumn]] = MS2_matrix[[eachColumn]]

    all_keys = pd.merge(all_matrix[name], MS2_matrix[name],how="outer")
    # print(all_keys)

    all_matrix = pd.merge(all_matrix, all_keys, how="right").replace("ID","MBR")
    MS2_matrix = pd.merge(MS2_matrix, all_keys, how="right")

    # print(all_matrix)
    for eachColumn in id_cols:
        # print(len(all_matrix[eachColumn]))
        # print(len(MS2_matrix[eachColumn]))
        if len(all_matrix[(all_matrix[name].isin(MS2_matrix[name]) & (MS2_matrix[eachColumn] == "MS2"))]) > 0:
            all_matrix.loc[(all_matrix[name].isin(MS2_matrix[name]) & (MS2_matrix[eachColumn] == "MS2")), [eachColumn]] = "MS2"

    # print(all_matrix)

    return all_matrix #noticed this changed


def sumIDs(IDMatrix):
    """_summarize the ID matrix infor into ID summary_
    

    Args:
        IDMatrix (_type_): _protein or pepetides matrix_
        0 Accession/Annotated Sequence 	run1 	run2 	run3 
        1 P023D12	MS2 	MBR 	NaN 
        2 P1222	NaN 	ID 	NaN 
    ID: means we don't know the ID mode

    Returns:
        _type_: _description_
                                      names  MS2_IDs  MBR_IDs  Total_IDs
0            10ng_QC_1_channel2 Intensity      NaN      NaN       3650
1            10ng_QC_2_channel1 Intensity      NaN      NaN       3604
....
    """
    # removes the columns that don't have ID data
    columns = [col for col in IDMatrix.columns if not any(
        substring in col for substring in [
            'Accession', 'Annotated Sequence'])]
    #put each ID_Modes into a list
    returnNames = []
    MS2_ID = []
    MBR_ID = []
    total_ID = []
    for eachColumn in columns:
        MS2_ID.append(len(IDMatrix[eachColumn][IDMatrix[eachColumn] == "MS2"])) #PD differentiates
        MBR_ID.append(len(IDMatrix[eachColumn][IDMatrix[eachColumn] == "MBR"])) #PD differentiates
        total_ID_each = len(IDMatrix[eachColumn][IDMatrix[eachColumn] == "ID"]) #some don't so we count total directly
        if total_ID_each == 0: #otherwise we sum
            total_ID_each = len(IDMatrix[eachColumn][
                IDMatrix[eachColumn] == "MS2"]) + len(IDMatrix[
                eachColumn][IDMatrix[eachColumn] == "MBR"])
        total_ID.append(total_ID_each)

    return pd.DataFrame({'names': columns,
                         'MS2_IDs': MS2_ID,
                         'MBR_IDs': MBR_ID,
                         'Total_IDs': total_ID})

def generate_column_from_name_mapping(columns, partial_column_name_mapping):
    #input is column names, and a dictionary with what you want each column (key) to be renamed to (value)
    column_name_mapping = {}
    for col in columns:
        for key, value in partial_column_name_mapping.items():
            if key in col: #in the case of PD, we are looking for a pattern within the column name
                column_name_mapping[col] = value
                break
    return column_name_mapping

def generate_column_to_name_mapping(columns, partial_column_name_mapping):
    #input is column names, and a dictionary with what you want each column (key) to be renamed to (value)
    column_name_mapping = {}
    for col in columns:
        for key, value in partial_column_name_mapping.items():
            if key == col:  #after we get away from PD's weirdness, then we want exact matches,
                            #so we don't get for example 1-11 when we look for 1-1 for file Identifiers or filenames
                column_name_mapping[col] = value
                break
    return column_name_mapping


def outer_join_data_objects(data_objects):
    '''
    Takes in a list of data objects as given by read_files and converts them to a single data object as given by read_files,
    protein info continues to show what was found on each original file, and so forth.
    '''

    first_file = True
    for eachDataObject in data_objects:
        print("***")
        if first_file:
            first_file = False
            final_data_object = eachDataObject
        else:
            final_data_object['run_metadata'] = pd.concat([final_data_object['run_metadata'],eachDataObject['run_metadata']]).reset_index(drop=True)
            final_data_object['protein_other_info'] = pd.concat([final_data_object['protein_other_info'],eachDataObject['protein_other_info']]).reset_index(drop=True)
            final_data_object['peptide_other_info'] = pd.concat([final_data_object['peptide_other_info'],eachDataObject['peptide_other_info']]).reset_index(drop=True)
            final_data_object['protein_ID_Summary'] = pd.concat([final_data_object['protein_ID_Summary'],eachDataObject['protein_ID_Summary']]).reset_index(drop=True)
            final_data_object['peptide_ID_Summary'] = pd.concat([final_data_object['peptide_ID_Summary'],eachDataObject['peptide_ID_Summary']]).reset_index(drop=True)
            duplicates_found = False
            
            #loop through to see if there are any duplicate files
            for eachCol in final_data_object['protein_abundance'].loc[:, final_data_object['protein_abundance'].columns!='Accession'].columns:
                if eachCol in eachDataObject['protein_abundance'].columns:
                    duplicates_found = True
                else:
                    pass
            for eachCol in final_data_object['protein_ID_matrix'].loc[:, final_data_object['protein_ID_matrix'].columns!='Accession'].columns:
                if eachCol in eachDataObject['protein_ID_matrix'].columns:
                    duplicates_found = True
                else:
                    pass
            for eachCol in final_data_object['peptide_abundance'].loc[:, final_data_object['peptide_abundance'].columns!='Annotated Sequence'].columns:
                if eachCol in eachDataObject['peptide_abundance'].columns:
                    duplicates_found = True
                else:
                    pass
            for eachCol in final_data_object['peptide_ID_matrix'].loc[:, final_data_object['peptide_ID_matrix'].columns!='Annotated Sequence'].columns:
                if eachCol in eachDataObject['peptide_ID_matrix'].columns:
                    duplicates_found = True
                else:
                    pass     
            if duplicates_found:
                print("Error: files analyzed twice present!!!")
                quit()
                print("@#afio2q3")
            else:
                #merge keeping all proteins
                # print("!!!!")
                final_data_object['protein_abundance'] = pd.merge(final_data_object['protein_abundance'],eachDataObject['protein_abundance'],how="outer")
                final_data_object['protein_ID_matrix'] = pd.merge(final_data_object['protein_ID_matrix'],eachDataObject['protein_ID_matrix'],how="outer")
                final_data_object['peptide_abundance'] = pd.merge(final_data_object['peptide_abundance'],eachDataObject['peptide_abundance'],how="outer")
                final_data_object['peptide_ID_matrix'] = pd.merge(final_data_object['peptide_ID_matrix'],eachDataObject['peptide_ID_matrix'],how="outer")
                
    return final_data_object
def filter_by_missing_values(data_object,
                             missing_value_thresh=33,
                             is_protein=True,
                             ignore_nan=False):
    """_Filter out proteins/peptides with missing values rate above the
    threshold_

    Args:
        data_object (_panada_): _dataframe contain data for one experimental
        condition_
        missing_value_thresh (int, optional): _description_. Defaults to 33.
        analysis_program (str, optional): _description_.
        ignore_nan: if filter intensity again with Nan threadshold, this 
        helps with the calcualting stdev step.

    Returns:
        _data_object_: _dictionary containing data for one experimental
         'abundances':        Accession  3_TrypsinLysConly_3A4_channel2 3_TrypsinLysConly_3BC_channel1
0     A0A096LP49                            0.00                                        10
1     A0A0B4J2D5                        89850.26                                      3311
2         A0AVT1                        83055.87                                    312312
    """
    if is_protein:
        name = "Accession"
        matrix_name = "protein_ID_matrix"
        other_info_name = "protein_other_info"
        abundance_name = "protein_abundance"
        
    else:
        name = "Annotated Sequence"
        matrix_name = "peptide_ID_matrix"
        other_info_name = "peptide_other_info"
        abundance_name = "peptide_abundance"

    #initializes number of missing values to zero
    protein_columns = data_object[matrix_name].assign(missingValues=0)

    i = 0
    # found all the proteins/peptides with missing values rate below
    # the threshold, pep_columns contains the remaining protein/peptide
    # in a pandas dataframe with $names as its column name
    for each_column in data_object[matrix_name].loc[
            :, ~data_object[matrix_name].columns.str.contains(name)&~data_object[matrix_name].columns.str.contains(
                "missingValues")].columns:
        # replace "nan" to np.nan
        protein_columns = protein_columns.replace({"nan": np.nan}) 
        #find missing values and increment those rows (a row is a protein/peptide) total number of missing values

        protein_columns.loc[(protein_columns[each_column] != "MS2")
                            &(protein_columns[each_column] != "MBR")
                            &(protein_columns[each_column] != "ID"), #this is more robust than using nan's in case something fails to convert
                             "missingValues"] += 1

        i += 1

    protein_columns = protein_columns.assign(missingValuesRate=(
        protein_columns["missingValues"] / i) * 100)
    
    protein_columns = protein_columns.loc[protein_columns["missingValuesRate"]<missing_value_thresh].reset_index()
    protein_columns = protein_columns.loc[:,
                                  protein_columns.columns.str.contains(name)]
    

    # filter the data_object with the remaining proteins/peptides names
    data_object[abundance_name] = protein_columns.merge(
        data_object[abundance_name], how="inner")
    data_object[matrix_name] = protein_columns.merge(
        data_object[matrix_name], how="inner")
    data_object[other_info_name] = protein_columns.merge(
        data_object[other_info_name], how="inner")
    # In case there is mismatch between ID table and abundance table,
    # mannually remove the row with all NaN values
    # keep rows in data_object[abundance_name] where at least two values are 
    # not NaN(do this to all rows except the first row), otherwise can't
    # calculate the stdev
    if ignore_nan:
        data_object[abundance_name] = data_object[abundance_name].dropna(
            how='all', subset=data_object[abundance_name].columns[1:]).reset_index()
        # This will cause the veen diagram to be different from R program
    
    return data_object

def filter_by_missing_values_MS2(data_object,
                             missing_value_thresh=33,
                             is_protein=True,
                             ignore_nan=False):
    """_Filter out proteins/peptides with missing values rate above the
    threshold_

    Args:
        data_object (_panada_): _dataframe contain data for one experimental
        condition_
        missing_value_thresh (int, optional): _description_. Defaults to 33.
        analysis_program (str, optional): _description_.
        ignore_nan: if filter intensity again with Nan threadshold, this 
        helps with the calcualting stdev step.

    Returns:
        _data_object_: _dictionary containing data for one experimental
         'abundances':        Accession  3_TrypsinLysConly_3A4_channel2
0     A0A096LP49                            0.00
1     A0A0B4J2D5                        89850.26
2         A0AVT1                        83055.87
    """
    if is_protein:
        name = "Accession"
        matrix_name = "protein_ID_matrix"
        other_info_name = "protein_other_info"
        abundance_name = "protein_abundance"
        
    else:
        name = "Annotated Sequence"
        matrix_name = "peptide_ID_matrix"
        other_info_name = "peptide_other_info"
        abundance_name = "peptide_abundance"

    protein_columns = data_object[matrix_name].assign(missingValues=0)

    i = 0
    # found all the proteins/peptides with missing values rate below
    # the threshold, pep_columns contains the remaining protein/peptide
    # in a pandas dataframe with $names as its column name
    for each_column in data_object[matrix_name].loc[:, ~data_object[matrix_name].columns.str.contains(name)&~data_object[matrix_name].columns.str.contains("missingValues")].columns:
        # replace "nan" to np.nan
        protein_columns = protein_columns.replace({"nan": np.nan}) 
        protein_columns.loc[protein_columns[each_column] != "MS2", #ID/MBR are still missing values if you are only considering MS2
                             "missingValues"] += 1

        i += 1

    protein_columns = protein_columns.assign(missingValuesRate=(
        protein_columns["missingValues"] / i) * 100)
    
    protein_columns = protein_columns.loc[protein_columns["missingValuesRate"]<missing_value_thresh].reset_index()
    protein_columns = protein_columns.loc[:,
                                  protein_columns.columns.str.contains(name)]

    # filter the data_object with the remaining proteins/peptides names
    data_object[abundance_name] = protein_columns.merge(
        data_object[abundance_name], how="inner")
    data_object[matrix_name] = protein_columns.merge(
        data_object[matrix_name], how="inner")
    data_object[other_info_name] = protein_columns.merge(
        data_object[other_info_name], how="inner")
    # In case there is mismatch between ID table and abundance table,
    # mannually remove the row with all NaN values
    # keep rows in data_object[abundance_name] where at least two values are 
    # not NaN(do this to all rows except the first row), otherwise can't
    # calculate the stdev
    if ignore_nan:
        data_object[abundance_name] = data_object[abundance_name].dropna(
            how='all', subset=data_object[abundance_name].columns[1:]).reset_index()
        # This will cause the veen diagram to be different from R program
    
    return data_object

def NormalizeToMedian(abundance_data, apply_log2=False):
    """_Normalizes each column by multiplying each value in that column with
    the median of all values in abundances (all experiments) and then dividing
    by the median of that column (experiment)._
    we find applying log2 transform first gives more robust results for PCA etc.
    See https://pubs.acs.org/doi/10.1021/acsomega.0c02564
    Args:
        abundance_data (_pd_): _description_
        apply_log2 (_bool_,): _apply log2 to all result_.
    Returns:
        _type_: _description_
        format:
         'abundances':        Accession  3_TrypsinLysConly_3A4_channel2
         A0A096LP49                    0.000000e+00
    """
    # all the columns/sample list
    columns = [col for col in abundance_data.select_dtypes(include=[
            np.number])]
    data_matrix = abundance_data[columns].values
    # replace 0 with nan
    # data_matrix[data_matrix == 0] = np.nan
    medianOfAll = np.nanmedian(data_matrix)
    
    #normalize all median, all median/current run all protein median
    # apply log2 to all the values if apply_log2 is True
    if apply_log2:    
        for each_column in columns:
            abundance_data[each_column] = (
                np.log2(medianOfAll) * np.log2(abundance_data[each_column]) /
                np.log2(np.nanmedian(abundance_data[
                    # each_column].replace(0, np.nan))))
                    each_column])))
    else:
        for each_column in columns:
            abundance_data[each_column] = (
                medianOfAll * abundance_data[each_column] /
                np.nanmedian(abundance_data[
                    # each_column].replace(0, np.nan)))
                    each_column]))
    #TODO divide by zero error encountered in log2, temporarily set to 0
    abundance_data = abundance_data.replace([np.inf, -np.inf], 0)

    return abundance_data

def calculate_cvs(abundance_data):
    """_Calculate mean, stdev, cv for withn each protein/peptide abundance_

    Args:
        data_object (_type_): _full data frame_

    Returns:
        _type_: _df with Accession mean, stdev, cv for each protein/peptide_
    """
    if 'Accession' in abundance_data.columns:
        name = "Accession"
    if 'Annotated Sequence' in abundance_data.columns:
        name = "Annotated Sequence"
    abundance_data = abundance_data.assign(
        intensity=abundance_data.loc[:, ~abundance_data.columns.str.contains(
            name)&~abundance_data.columns.str.contains("missingValues")].mean(axis=1, skipna=True),
        stdev=abundance_data.loc[:, ~abundance_data.columns.str.contains(
            name)&~abundance_data.columns.str.contains("missingValues")].std(axis=1, skipna=True),
        CV=abundance_data.loc[:, ~abundance_data.columns.str.contains(name)&~abundance_data.columns.str.contains("missingValues")].std(
            axis=1) / abundance_data.loc[:, ~abundance_data.columns.str.contains(name)&~abundance_data.columns.str.contains("missingValues")].mean(
            axis=1) * 100)

    abundance_data = abundance_data.loc[:, [
            name, "intensity", "stdev", "CV"]]
    
    return abundance_data

def t_test_from_summary_stats(m1, m2, n1, n2, s1, s2, equal_var=False):
    """_Calculate T-test from summary using ttest_ind_from_stats from
    scipy.stats package_

    Args:
        m1 (_type_): _mean list of sample 1_
        m2 (_type_): mean list of sample 2_
        n1 (_type_): sample size list of sample 1_
        n2 (_type_): sample size list of sample 2_
        s1 (_type_): standard deviation list of sample 1_
        s2 (_type_): standard deviation list of sample 2_
        equal_var (_type_, optional): False would perform Welch's
        t-test, while set it to True would perform Student's t-test. Defaults
        to False.

    Returns:
        _type_: _list of P values_
    """

    p_values = []
    for i in range(len(m1)):
        _, benjamini = ttest_ind_from_stats(
            m1[i], s1[i], n1[i], m2[i], s2[i], n2[i], equal_var=equal_var)
        p_values.append(benjamini)

    return p_values

def impute_knn(abundance_data, k=5):
    """_inpute missing value from neighbor values_

    Args:
        abundance_data (_type_): _description_
        k (int, optional): _number of neighbors used_. Defaults to 5.
    Returns:
        _type_: _description_
        TODO: this knn imputer produces slightly different results (about 4%)
        from the one in R. Need to figure out why
    """
    name = abundance_data.columns[0]

    names = abundance_data[name]
    # x = abundance_data.select_dtypes(include=['float64', 'int64'])
    # imputer = KNNImputer(n_neighbors=k)
    # x_imputed = pd.DataFrame(imputer.fit_transform(x), columns=x.columns)


    x = abundance_data.select_dtypes(include=['float', 'int'])
    imputer = KNNImputer(n_neighbors=k)
    x_imputed = imputer.fit_transform(x)
    x_imputed = pd.DataFrame(x_imputed, columns=x.columns)



    abundance_data.loc[:, x.columns] = x_imputed.values
    abundance_data[name] = names
    return abundance_data

def CalculatePCA(abundance_object, infotib,log2T = False):
    """_inpute PCA transformed and variance explained by each principal
    component_
    """
    name = abundance_object.columns[0]
    x = abundance_object
    
    sampleNames = x.columns[~x.columns.str.contains(
        name)].to_frame(index=False)

    if log2T: #apply log2 transformation
        x = np.log2(x.loc[:, ~x.columns.str.contains(name)].T.values)
    else:
        x = x.loc[:, ~x.columns.str.contains(name)].T.values
    # filter out columns with all zeros
    is_finite_col = np.isfinite(np.sum(x, axis=0))
    x_filtered = x[:, is_finite_col]

    
    # Instantiate PCA    
    pca = PCA()
    #
    # Determine transformed features
    #
    x_pca = pca.fit_transform(x_filtered)
    #
    # Determine explained variance using explained_variance_ration_ attribute
    #
    exp_var_pca = pca.explained_variance_ratio_
    #
    # Cumulative sum of eigenvalues; This will be used to create step plot
    # for visualizing the variance explained by each principal component.
    #
    cum_sum_eigenvalues = np.cumsum(exp_var_pca)
    #
    # convert numpy array to pandas dataframe for plotting
    
    pca_panda = pd.DataFrame(x_pca, columns=[
        'PC' + str(i+1) for i in range(x_pca.shape[1])])
    # add sample names to the dataframe
    pca_panda = pd.concat(
        [infotib, pca_panda], axis=1, join='inner')
    
    return pca_panda, exp_var_pca


def filter_by_name(data_dict, runname_list):
    """_Filter the data_dict based on runname_list, only keep the columns
    of the data_dict that are in the runname_list_
    Args:

    Returns:
        _type_: _description_
    """

    # make dict for each runname, no accession/sequence
    nameDict = dict(zip(data_dict["run_metadata"]["Run Names"],data_dict["run_metadata"]["Run Identifier"]))
    
    identifier_list = []
    
    identifier_list_plus = []
    if "Annotated Sequence" in runname_list:
        runname_list.remove("Annotated Sequence")
    if "Accession" in runname_list:
        runname_list.remove("Accession")
    for eachName in runname_list:
        identifier_list.append(nameDict[eachName])

    for eachName in runname_list:
        identifier_list_plus.append(nameDict[eachName])


    filtered_data = {}
   # filtered_data["meta"] = data_dict["meta"]
    runname_list.extend(["Annotated Sequence","Accession"])
    identifier_list_plus.extend(["Annotated Sequence","Accession"])

    #filtered_data["run_metadata"] = [item for item in data_dict[
    #   "run_metadata"] if item in runname_list]
    
    filtered_data["run_metadata"] = data_dict["run_metadata"][
        data_dict["run_metadata"]["Run Names"].isin(
            runname_list)]  
    filtered_data["protein_abundance"] = data_dict["protein_abundance"][[
        col for col in data_dict["protein_abundance"].columns if any(
            word == col for word in identifier_list_plus)]]
    filtered_data["peptide_abundance"] = data_dict["peptide_abundance"][[
        col for col in data_dict["peptide_abundance"].columns if any(
            word == col for word in identifier_list_plus)]]
    filtered_data["protein_other_info"] = data_dict["protein_other_info"][[
        col for col in data_dict["protein_other_info"].columns if any(
            word == col for word in identifier_list_plus)]]
    filtered_data["peptide_other_info"] = data_dict["peptide_other_info"][[
        col for col in data_dict["peptide_other_info"].columns if any(
            word == col for word in identifier_list_plus)]]
    filtered_data["protein_ID_matrix"] = data_dict["protein_ID_matrix"][[
        col for col in data_dict["protein_ID_matrix"].columns if any(
            word == col for word in identifier_list_plus)]]
    filtered_data["peptide_ID_matrix"] = data_dict["peptide_ID_matrix"][[
        col for col in data_dict["peptide_ID_matrix"].columns if any(
            word == col for word in identifier_list_plus)]]
    filtered_data["protein_ID_Summary"] = data_dict["protein_ID_Summary"][
        data_dict["protein_ID_Summary"]["names"].isin(
            identifier_list)]
    filtered_data["peptide_ID_Summary"] = data_dict["peptide_ID_Summary"][
        data_dict["peptide_ID_Summary"]["names"].isin(
            identifier_list)]
    return filtered_data
def ID_plots(data_object, plot_options, saved_settings, username=None):
    """_Prepare data for creating protein peptide identification bar
    plot_

    Args:
        data_dict (_type_): _description_
    """
    # Create an empty dictionary to store the group names and filters
    group_names = [key for key in saved_settings.keys() if "Order@" not in str(key)]

    # import the data and save order
    group_dict = {}

    if plot_options["ID mode"] == "MS2" or plot_options["ID mode"] == "total" or plot_options["ID mode"] == "stacked":
        x_axis_order = saved_settings["Order@Conditions"]
    elif plot_options["Group By X"] == "ID_Mode":
        print("ERROR: x axis separation of MS2/MBR not supported")
    else:
        x_axis_order = saved_settings["Order@"+plot_options["Group By X"]]
    if plot_options["ID mode"] == "grouped" or plot_options["ID mode"] == "grouped_stacked" and plot_options["Group By Color"] != "ID_Mode":
        color_order = saved_settings["Order@"+plot_options["Group By Color"]]
        plot_options["color_order"] = color_order

    plot_options["x_axis_order"] = x_axis_order

    # filter runs into different groups
    i = 1
    runname_list = []  # contain list of run names list for each groups
    for eachGroup in group_names:
        runname_sublist = saved_settings[eachGroup]["records"]

        group_dict[eachGroup] = filter_by_name(
            data_object,
            runname_sublist)  # prevent the list from being changed
        runname_list.append(runname_sublist)
        i += 1

        #print(group_dict[eachGroup]["run_metadata"])
    #display(data_object["protein_ID_Summary"])
    #display(group_dict[eachGroup]["protein_ID_Summary"])
    # create ID plots
    # allIDs table will be used to store all experiment name, ID types (
    # protein, peptide, MS2 and MS1 based), conditions and IDs numbers
    allIDs = pd.DataFrame(
        columns=["Names", "ID_Type", "ID_Mode", "Conditions", "IDs"])

    # loop through each group and extract IDs, put them into allIDs table
    for eachCondition in group_names:
        # Protein ID summary
        for index, row in group_dict[eachCondition][
                "protein_ID_Summary"].iterrows():
            for item in ["MS2_IDs",
                         "MBR_IDs",
                         "Total_IDs"]:
                if not pd.isna(group_dict[eachCondition][
                        "protein_ID_Summary"].at[index, item]):
                    # if the row with the item column is not empty,
                    # add it to allIDs table.
                    allIDs = pd.concat(
                        [allIDs,
                         pd.DataFrame(
                             [[group_dict[eachCondition][
                                 "protein_ID_Summary"].at[index, "names"],
                              "protein",
                               item,
                               eachCondition,
                               group_dict[eachCondition][
                                 "protein_ID_Summary"].at[index, item]]],
                             columns=["Names",
                                      "ID_Type",
                                      "ID_Mode",
                                      "Conditions",
                                      "IDs"])],
                        ignore_index=True)
        # Peptide ID summary
        for index, row in group_dict[eachCondition][
                "peptide_ID_Summary"].iterrows():
            for item in ["MS2_IDs",
                         "MBR_IDs",
                         "Total_IDs"]:
                if not pd.isna(group_dict[eachCondition][
                        "peptide_ID_Summary"].at[index, item]):
                    allIDs = pd.concat(
                        [allIDs,
                         pd.DataFrame(
                             [[group_dict[eachCondition][
                                 "peptide_ID_Summary"].at[index, "names"],
                              "peptide",
                               item,
                               eachCondition,
                               group_dict[eachCondition][
                                 "peptide_ID_Summary"].at[index, item]]],
                             columns=["Names",
                                      "ID_Type",
                                      "ID_Mode",
                                      "Conditions",
                                      "IDs"])],
                        ignore_index=True)
    # ######################allIDs format###################
    # name	ID_Type	ID_Mode	Conditions	IDs
    # file1	peptide	MS2_IDs	experimetn 1	xxxxx
    # file2	protein	MBR_IDs	experiment 2	xxxx
    # file3	peptide	Total_IDs	experiment 3	xxx
    #######################################################
    # Calcuate mean, standard deviation and number of replicates for each
    export_ids = allIDs.copy()
    # choose protein or peptide
    if plot_options["plot_type"] == "1":  # Protein ID
        allIDs = allIDs[allIDs["ID_Type"] == "protein"]
    elif plot_options["plot_type"] == "2":  # Peptide ID
        allIDs = allIDs[allIDs["ID_Type"] == "peptide"]

    # choose total, MS2 or stacked
    if plot_options["ID mode"] == "MS2":  # MS2 ID
        allIDs = allIDs[allIDs["ID_Mode"] == "MS2_IDs"]
    elif plot_options["ID mode"] == "total":
        # total ID combined, if not already summed (key exist), sum them
#         if allIDs[allIDs["ID_Mode"] == "Total_IDs"].empty:
#             grouped = allIDs.groupby('name').agg(
#                 {'IDs': 'sum', 'ID_Type': 'first', 'Conditions': 'first'})
#             grouped = grouped.reset_index()
#             grouped["ID_Mode"] = "Total_IDs"
#             allIDs = grouped
        allIDs = allIDs[allIDs["ID_Mode"] == "Total_IDs"]
    elif plot_options["Group By X"] == "ID_Mode" or plot_options["Group By Color"] == "ID_Mode" \
        or plot_options["Group By Stack"] == "ID_Mode" and not (plot_options["ID mode"] == "total" or plot_options["ID mode"] == "MS2"):  # total separated
        pass
    elif plot_options["ID mode"] == "MS2":
        allIDs = allIDs[allIDs["ID_Mode"] == "MS2_IDs"]
    else:
        allIDs = allIDs[allIDs["ID_Mode"] == "Total_IDs"]

    toPlotIDs = allIDs.groupby(["ID_Mode", "Conditions"]).agg({
        'IDs': ['mean', 'std', 'count'], 'ID_Type': 'first', })

    # rename the columns
    toPlotIDs.columns = ['IDs', 'stdev', 'n', 'ID_Type']
    # reset the index after grouping
    toPlotIDs = toPlotIDs.reset_index()
    # calculate the confidence interval based on 95%confidence interval`
    toPlotIDs["confInt"] = t.ppf(0.975, toPlotIDs['n']-1) * \
        toPlotIDs['stdev']/np.sqrt(toPlotIDs['n'])

    #add columns for the categories specified in settings file (the one with all the filenames)
    standard_groups = ["filter_in","filter_out","records"]
    categories = [col for col in list(saved_settings[list(group_names)[0]].keys()) if col not in standard_groups]
    for eachCategory in categories:
        toPlotIDs[eachCategory] = ""
        for eachGroup in group_names:
            toPlotIDs.loc[toPlotIDs["Conditions"]==eachGroup,eachCategory] = saved_settings[eachGroup][eachCategory]
    
    #display(toPlotIDs)
    fig = plot_IDChart_plotly(toPlotIDs,
                               username=username,
                               plot_options=plot_options)

    if WRITE_OUTPUT:    
        # export the data to csv for user downloading
        data_dir = os.path.join(APPFOLDER, "csv/")
        # create the directory if it does not exist
        if not os.path.exists(data_dir):
            Path(data_dir).mkdir(parents=True)
        categories = [col for col in list(saved_settings[list(group_names)[0]].keys()) if col not in standard_groups]
        
        for eachCategory in categories:
            export_ids[eachCategory] = ""
            for eachGroup in group_names:
                export_ids.loc[export_ids["Conditions"]==eachGroup,eachCategory] = saved_settings[eachGroup][eachCategory]
        export_ids = export_ids.replace({"Names": dict(zip(data_object["run_metadata"]["Run Identifier"],data_object["run_metadata"]["Run Names"]))})
        
        # export the data to csv
        export_ids.to_csv(os.path.join(
            data_dir, f"{username}_ID_data.csv"), index=False)
        

        # create the link for downloading the data
        CSV_link = f"/files/{url_base}/csv/" \
            f"{username}_ID_data.csv"

        # add SVG download link

        SVG_link = f"/files/{url_base}/images/" \
            f"{username}_ID_Bar_Plot.svg"

        img_dir = os.path.join(APPFOLDER, "images/")
        if not os.path.exists(img_dir):
            Path(img_dir).mkdir(parents=True)

        fig.write_image(os.path.join(
            img_dir, f"{username}_ID_Bar_Plot.svg"), format = "svg", validate = False, engine = "kaleido")


    else:
        CSV_link = None
        SVG_link = None
    return fig, CSV_link, SVG_link

def plot_IDChart_plotly(ID_data,
                        username=None,
                        plot_options=None):
    """_Plot the ID bar plot for the given data_

    Args:
        ID_data (_type_): _description_
        username (str, optional): _description_. Defaults to "test".
        plot_options (_type_, optional): _description_. Defaults to None.

    Returns:
        _type_: _description_
    """

    plot_div = None
    

    if plot_options["ID mode"] == "grouped":  
        # plot options
        # error bar
        if plot_options["error bar"] == "stdev":
            error_bars = "stdev"
            error_visibile = True
        elif plot_options["error bar"] == "ci95":
            error_bars = "confInt"
            error_visibile = True
        else:
            error_bars = "stdev"
            error_visibile = False

        # mean label
        if plot_options["mean label"] == "True" or \
                plot_options["mean label"] == True:
            total_labels = [{"x": x, "y": total*1.15, "text": str(
                int(total)), "showarrow": False} for x, total in zip(
                    ID_data["Conditions"], ID_data["IDs"])]
        else:
            total_labels = []   # no mean labels

        if plot_options["Group By X"] == "ID_Mode" or plot_options["Group By Color"] == "ID_Mode":  # total separated
            ID_data = ID_data[ID_data["ID_Mode"] != "Total_IDs"]
        else:
            ID_data = ID_data[ID_data["ID_Mode"] == "Total_IDs"]
        #find out present categories
        categories = plot_options["color_order"]
        # create the plot
        fig_data = []
        i = 0
        for eachCategory in categories:
            fig_data.append(go.Bar(name = eachCategory,
                        x=ID_data.loc[ID_data[plot_options["Group By Color"]]==eachCategory,plot_options["Group By X"]].tolist(),
                        y=ID_data.loc[ID_data[plot_options["Group By Color"]]==eachCategory,"IDs"].tolist(),
                        marker_color = plot_options["color"][i],
                        text = [round(x) for x in ID_data.loc[ID_data[plot_options["Group By Color"]]==eachCategory,"IDs"].tolist()],
                        error_y=dict(
                            type = "data",
                            array = ID_data.loc[ID_data[plot_options["Group By Color"]]==eachCategory,error_bars].tolist(),
                            visible = error_visibile
                        )))
            i = i + 1                    

        fig = go.Figure(data = fig_data,
                        layout=go.Layout(yaxis_title=plot_options["Y Title"],
                        xaxis_title=plot_options["Group By X"],
                        barmode="group",paper_bgcolor="rgba(255,255,255,255)",
                        plot_bgcolor="rgba(255, 255, 255, 255)",
                        yaxis=dict(showline=True, linewidth=1, linecolor='black'),
                        xaxis=dict(showline=True, linewidth=1, linecolor='black')))
        fig.update_xaxes(categoryorder='array', categoryarray = plot_options["x_axis_order"])

    elif plot_options["ID mode"] == "stacked":
        # plot options
        # error bar
        if plot_options["error bar"] == "stdev":
            error_bars = "stdev"
            error_visibile = True
        elif plot_options["error bar"] == "ci95":
            error_bars = "confInt"
            error_visibile = True
        else:
            error_bars = "stdev"
            error_visibile = False

        # mean label
        if plot_options["mean label"] == "True" or \
                plot_options["mean label"] == True:
            total_labels = [{"x": x, "y": total*1.15, "text": str(
                int(total)), "showarrow": False} for x, total in zip(
                    ID_data["Conditions"], ID_data["IDs"])]
        else:
            total_labels = []   # no mean labels
        if plot_options["Group By X"] == "ID_Mode" or plot_options["Group By Stack"] == "ID_Mode":  # total separated
            # ID_data = ID_data[ID_data["ID_Mode"] != "Total_IDs"]
            pass
        else:
            ID_data = ID_data[ID_data["ID_Mode"] == "Total_IDs"]

        if plot_options["Group By Stack"] == "ID_Mode":
            layers = ["MS2_IDs", "MBR_IDs"]
        else:
            layers = ID_data.groupby(plot_options["Group By Stack"]).first().reset_index()[plot_options["Group By Stack"]].tolist()
        fig_data = []
        last_layer = None
        i = 0
        for eachLayer in layers: 
            if eachLayer == "MBR_IDs":
                fig_data.append(go.Bar(
                    name = eachLayer,
                    x = ID_data.loc[(ID_data[plot_options["Group By Stack"]]==eachLayer),plot_options["Group By X"]].tolist(),
                    y = ID_data.loc[(ID_data[plot_options["Group By Stack"]]==eachLayer),"IDs"].tolist(),
                    base=bases,
                    marker_color = plot_options["color"][i],
                    opacity=0.5,
                    text = [round(x) for x in bases + ID_data.loc[(ID_data[plot_options["Group By Stack"]]=="Total_IDs"),"IDs"].tolist()],
                    error_y= dict(
                        type = "data",
                        array = ID_data.loc[ID_data[plot_options["Group By Stack"]]=="Total_IDs",error_bars].tolist(),
                        visible = error_visibile
                    )
                ))
                i = i + 1
            elif last_layer == None:
                fig_data.append(go.Bar(
                    name = eachLayer,
                    x = ID_data.loc[(ID_data[plot_options["Group By Stack"]]==eachLayer),plot_options["Group By X"]].tolist(),
                    y = ID_data.loc[(ID_data[plot_options["Group By Stack"]]==eachLayer),"IDs"].tolist(),
                    marker_color = plot_options["color"][i],
                    text = [round(x) for x in ID_data.loc[(ID_data[plot_options["Group By Stack"]]==eachLayer),"IDs"].tolist()],
                    error_y= dict(
                        type = "data",
                        array = ID_data.loc[ID_data[plot_options["Group By Stack"]]==eachLayer,error_bars].tolist(),
                        visible = error_visibile
                    )
                ))
                bases = ID_data.loc[(ID_data[plot_options["Group By Stack"]]==eachLayer),"IDs"]
                i = i + 1
                
            else:
                fig_data.append(go.Bar(
                    name = eachLayer,
                    x = ID_data.loc[(ID_data[plot_options["Group By Stack"]]==eachLayer),plot_options["Group By X"]].tolist(),
                    y = ID_data.loc[(ID_data[plot_options["Group By Stack"]]==eachLayer),"IDs"].tolist(),
                    base=bases,
                    marker_color = plot_options["color"][i],
                    opacity=0.5,
                    text = [round(x) for x in bases + ID_data.loc[(ID_data[plot_options["Group By Stack"]]==eachLayer),"IDs"].tolist()],
                    error_y= dict(
                        type = "data",
                        array = ID_data.loc[ID_data[plot_options["Group By Stack"]]==eachLayer,error_bars].tolist(),
                        visible = error_visibile
                    )
                ))
                print(bases)
                bases = bases + ID_data.loc[(ID_data[plot_options["Group By Stack"]]==eachLayer),"IDs"].tolist()
            last_layer = eachLayer
        fig = go.Figure(
                data = fig_data,
                layout=go.Layout(
                yaxis_title=plot_options["Y Title"],
                xaxis_title=plot_options["Group By X"],
                barmode="stack", 
                paper_bgcolor="rgba(255,255,255,255)",
                plot_bgcolor="rgba(255, 255, 255, 255)",
                yaxis=dict(showline=True, linewidth=1, linecolor='black'),
                xaxis=dict(showline=True, linewidth=1, linecolor='black')
            ))          
        fig.update_xaxes(categoryorder='array', categoryarray = plot_options["x_axis_order"])            
    elif plot_options["ID mode"] == "grouped_stacked":
        # plot options
        # error bar
        if plot_options["error bar"] == "stdev":
            error_bars = "stdev"
            error_visibile = True
        elif plot_options["error bar"] == "ci95":
            error_bars = "confInt"
            error_visibile = True
        else:
            error_bars = "stdev"
            error_visibile = False

        # mean label
        if plot_options["mean label"] == "True" or \
                plot_options["mean label"] == True:
            total_labels = [{"x": x, "y": total*1.15, "text": str(
                int(total)), "showarrow": False} for x, total in zip(
                    ID_data["Conditions"], ID_data["IDs"])]
        else:
            total_labels = []   # no mean labels

        if plot_options["Group By X"] == "ID_Mode" or plot_options["Group By Color"] == "ID_Mode"or plot_options["Group By Stack"] == "ID_Mode":  # total separated
            # ID_data = ID_data[ID_data["ID_Mode"] != "Total_IDs"]
            pass # no need to remove it
        else:
            ID_data = ID_data[ID_data["ID_Mode"] == "Total_IDs"]

        #make data tidy
        if plot_options["Group By Stack"] == "ID_Mode":
            layers = ["MS2_IDs", "MBR_IDs"]
        else:
            layers = ID_data.groupby(plot_options["Group By Stack"]).first().reset_index()[plot_options["Group By Stack"]].tolist()
        categories = plot_options["color_order"]
        
        fig_data = []
        i = 0
        color =0
        # print(categories)
        # display(ID_data)
        for eachCategory in categories:
            last_layer = None
            j = 0
            for eachLayer in layers: 
                if eachLayer == "MBR_IDs":
                    fig_data.append(go.Bar(
                        name = str(eachLayer) + " " + str(eachCategory),
                        x = ID_data.loc[(ID_data[plot_options["Group By Color"]]==eachCategory)&(ID_data[plot_options["Group By Stack"]]==eachLayer),plot_options["Group By X"]],
                        y = ID_data.loc[(ID_data[plot_options["Group By Color"]]==eachCategory)&(ID_data[plot_options["Group By Stack"]]==eachLayer),"IDs"],
                        base=bases,
                        offsetgroup=i,
                        #text = [round(x) for x in ID_data.loc[(ID_data[plot_options["Group By Color"]]==eachCategory)&(ID_data[plot_options["Group By Stack"]]==eachLayer),"IDs"].tolist()+bases],
                        marker_color = plot_options["color"][color],
                        opacity=1/2**j,
                        #bar size
                        width = plot_options["bar_width"],
                        error_y = dict(
                            type = "data",
                            array = ID_data.loc[(ID_data[plot_options["Group By Color"]]==eachCategory)&(ID_data[plot_options["Group By Stack"]]=="Total_IDs"),error_bars],
                            visible=True)
                        ))
                    bases = bases + ID_data.loc[(ID_data[plot_options["Group By Color"]]==eachCategory)&(ID_data[plot_options["Group By Stack"]]==eachLayer),"IDs"].tolist()
                elif last_layer == None:
                    fig_data.append(go.Bar(
                        name = str(eachLayer) + " " + str(eachCategory),
                        x = ID_data.loc[(ID_data[plot_options["Group By Color"]]==eachCategory)&(ID_data[plot_options["Group By Stack"]]==eachLayer),plot_options["Group By X"]],
                        y = ID_data.loc[(ID_data[plot_options["Group By Color"]]==eachCategory)&(ID_data[plot_options["Group By Stack"]]==eachLayer),"IDs"],
                        offsetgroup=i,
                        #bar size
                        width = plot_options["bar_width"],
                        #text = [round(x) for x in ID_data.loc[(ID_data[plot_options["Group By Color"]]==eachCategory)&(ID_data[plot_options["Group By Stack"]]==eachLayer),"IDs"].tolist()],
                        marker_color = plot_options["color"][color],
                        error_y = dict(
                            type = "data",
                            array = ID_data.loc[(ID_data[plot_options["Group By Color"]]==eachCategory)&(ID_data[plot_options["Group By Stack"]]==eachLayer),error_bars],
                            visible=True)
                    ))
                    bases = ID_data.loc[(ID_data[plot_options["Group By Color"]]==eachCategory)&(ID_data[plot_options["Group By Stack"]]==eachLayer),"IDs"]
                else:

                    fig_data.append(go.Bar(
                        name = str(eachLayer) + " " + str(eachCategory),
                        x = ID_data.loc[(ID_data[plot_options["Group By Color"]]==eachCategory)&(ID_data[plot_options["Group By Stack"]]==eachLayer),plot_options["Group By X"]],
                        y = ID_data.loc[(ID_data[plot_options["Group By Color"]]==eachCategory)&(ID_data[plot_options["Group By Stack"]]==eachLayer),"IDs"],
                        base=bases,
                        offsetgroup=i,
                        #text = [round(x) for x in ID_data.loc[(ID_data[plot_options["Group By Color"]]==eachCategory)&(ID_data[plot_options["Group By Stack"]]==eachLayer),"IDs"].tolist()+bases],
                        marker_color = plot_options["color"][color],
                        opacity=1/2**j,
                        #bar size
                        width = plot_options["bar_width"],
                        error_y = dict(
                            type = "data",
                            array = ID_data.loc[(ID_data[plot_options["Group By Color"]]==eachCategory)&(ID_data[plot_options["Group By Stack"]]==eachLayer),error_bars],
                            visible=True)
                        ))
                    bases = bases + ID_data.loc[(ID_data[plot_options["Group By Color"]]==eachCategory)&(ID_data[plot_options["Group By Stack"]]==eachLayer),"IDs"].tolist()
                last_layer=eachLayer
                j = j + 1
                color = color + 1
            i = i + 1

        fig = go.Figure(
            fig_data,
            layout=go.Layout(
                yaxis=dict(
                    title=dict(
                        text=plot_options["Y Title"],  # Set the title text
                        font=plot_options["font"], 
                        ),
                    linewidth=1, 
                    linecolor='black',
                    tickfont=plot_options["font"]
                    ),
                 xaxis=dict(
                    title=dict(
                        text=plot_options["Group By X"],  # Set the title text
                        font=plot_options["font"], 
                        ),
                    showline=True, 
                    linewidth=1, 
                    linecolor='black',
                    tickfont=plot_options["font"]),
                barmode="group",
                plot_bgcolor="rgba(255, 255, 255, 255)",
                paper_bgcolor="rgba(255, 255, 255, 255)",
                showlegend=False,
            )
        )
        fig.update_xaxes(categoryorder='array', categoryarray = plot_options["x_axis_order"])
    else:

        # plot options
        # error bar
        if plot_options["error bar"] == "stdev":
            error_bars = "stdev"
        elif plot_options["error bar"] == "ci95":
            error_bars = "confInt"
        else:
            error_bars = None

        # mean label
        if plot_options["mean label"] == "True" or \
                plot_options["mean label"] == True:
            total_labels = [{"x": x, "y": total*1.15, "text": str(
                int(total)), "showarrow": False} for x, total in zip(
                    ID_data["Conditions"], ID_data["IDs"])]
        else:
            total_labels = []   # no mean labels

        # create the plot
        fig = px.bar(ID_data,
                     x="Conditions",
                     y="IDs",
                     error_y=error_bars,
                     color="Conditions",
                     color_discrete_sequence=plot_options["color"],
                     width=plot_options["width"],
                     height=plot_options["height"],

                     )
        fig.update_layout(xaxis_title=plot_options["X Title"],
                          yaxis_title=plot_options["Y Title"],
                          annotations=total_labels,
                          font=plot_options["font"],
                          plot_bgcolor ="rgba(255, 255, 255, 255)",
                          paper_bgcolor="rgba(255, 255, 255, 255)",
                          yaxis=dict(showline=True, linewidth=1, linecolor='black'),
                          xaxis=dict(showline=True, linewidth=1, linecolor='black'),

                          )
        fig.update_xaxes(categoryorder='array', categoryarray = plot_options["x_axis_order"])
    return fig


# CV Violin plots ###
def CV_plots(data_object, plot_options, saved_settings, username=None):
    """_Prepare data for creating protein CV violin plots_
    """
    group_names = [key for key in saved_settings.keys() if "Order@" not in str(key)]
    plot_options["median label"] = True if plot_options["median label"] == "True" else False
    plot_options["box"] = True if plot_options["box"] == "True" else False
    plot_options["show Legend"] = True if plot_options["show Legend"] == "True" else False
    # import the data and save order
    group_dict = {}

    if plot_options["CV mode"] == "MS2" or plot_options["CV mode"] == "total" or plot_options["CV mode"] == "stacked":
        x_axis_order = saved_settings["Order@Conditions"]
    else:
        x_axis_order = saved_settings["Order@"+plot_options["Group By X"]]
    plot_options["x_axis_order"] = x_axis_order
    if plot_options["CV mode"] == "grouped" or plot_options["CV mode"] == "grouped_stacked" and plot_options["Group By Color"] != "ID_Mode":
        color_order = saved_settings["Order@"+plot_options["Group By Color"]]
        plot_options["color_order"] = color_order
    # filter runs into different groups
    i = 1
    runname_list = []  # contain list of run names list for each groups
    for eachGroup in group_names:
        runname_sublist = saved_settings[eachGroup]["records"]
        
        group_dict[eachGroup] = filter_by_name(
            data_object,
            list(runname_sublist))  # prevent the list from being changed
        runname_list.append(runname_sublist)
        i += 1
    if plot_options["plot_type"] == 1 or plot_options["plot_type"] == "1":
        matrix_name = "protein_abundance"
    elif plot_options["plot_type"] == 2 or plot_options["plot_type"] == "2":
        matrix_name = "peptide_abundance" 

    # create a dictionary to store the intensity data
    Intensity_dict = {}
    if plot_options["Group By X"] == "ID_Mode"or plot_options["Group By Color"] == "ID_Mode" \
        or plot_options["Group By Stack"] == "ID_Mode"and not (plot_options["CV mode"] == "total" or plot_options["CV mode"] == "MS2"):  # total separated
        Intensity_dict_MS2 = {}
        for eachGroup in group_names:
            current_condition_data = group_dict[eachGroup]
            current_condition_data[matrix_name]=current_condition_data[matrix_name].dropna(how="all",subset=current_condition_data[matrix_name].columns[current_condition_data[matrix_name].columns.str.contains("-")])
            current_condition_data[matrix_name] = NormalizeToMedian(
                current_condition_data[matrix_name])
            meh = filter_by_missing_values(
                current_condition_data)
            Intensity_dict[eachGroup] = meh[matrix_name]

            
            current_condition_data_MS2 = filter_by_missing_values_MS2( #returns
                current_condition_data)
            Intensity_dict_MS2[eachGroup] = current_condition_data_MS2[matrix_name]
            
    elif plot_options["CV mode"] == "MS2":
        Intensity_dict_MS2 = {}
        for eachGroup in group_names:
            current_condition_data_MS2 = filter_by_missing_values_MS2(
                group_dict[eachGroup])
            Intensity_dict[eachGroup] = NormalizeToMedian(
                current_condition_data_MS2[matrix_name])
    else:
        for eachGroup in group_names:
            current_condition_data = filter_by_missing_values(
                group_dict[eachGroup])
            Intensity_dict[eachGroup] = NormalizeToMedian(
                current_condition_data[matrix_name])

    all_cvs = pd.DataFrame()

    for eachGroup in Intensity_dict:
        current = calculate_cvs(
            Intensity_dict[eachGroup]).assign(Conditions=eachGroup,ID_Mode="All IDs")
        all_cvs = pd.concat([all_cvs, current], ignore_index=True)
    if plot_options["Group By X"] == "ID_Mode"or plot_options["Group By Color"] == "ID_Mode"or plot_options["Group By Stack"] == "ID_Mode"and not plot_options["CV mode"] == "total":  # total separated  # total separated
        print("MS2 CVs...")
        for eachGroup in Intensity_dict_MS2:
            current = calculate_cvs(
                Intensity_dict_MS2[eachGroup]).assign(Conditions=eachGroup,ID_Mode="MS2 IDs")
            all_cvs = pd.concat([all_cvs, current], ignore_index=True)

    #add columns for the categories specified in settings file (the one with all the filenames)
    standard_groups = ["filter_in","filter_out","records"]
    categories = [col for col in list(saved_settings[list(group_names)[0]].keys()) if col not in standard_groups]
    for eachCategory in categories:
        all_cvs[eachCategory] = ""
        for eachGroup in group_names:
            all_cvs.loc[all_cvs["Conditions"]==eachGroup,eachCategory] = saved_settings[eachGroup][eachCategory]


    # ######################all_CVs format###################
#      Accession     intensity          stdev          CV   Conditions
# 0       A6NHR9  3.248547e+06  672989.819300   20.716643    DDMandDTT
# 1       A8MTJ3  5.031539e+05  195535.383583   38.861944    DDMandDTT
# 2       E9PAV3  5.330290e+05  161385.491163   30.277056    DDMandDT
    #######################################################

    return plot_CV_violin(allCVs=all_cvs,
                          username=username,
                          plot_options=plot_options)


def plot_CV_violin(allCVs,
                   username=None,
                   plot_options=None,
                   ):
    """_Plot the CV violin plot for the given data._

    Args:
        allCVs (_type_): _description_
        username (_type_, optional): _description_. Defaults to None.
        plot_options (_type_, optional): _description_. Defaults to None.

    Returns:
        _type_: _description_
    """
    plot_div = None
    CSV_link = None
    SVG_link = None

    group_names = [key for key in saved_settings.keys() if "Order@" not in str(key)]

    allCVs_summary = allCVs.groupby(["Conditions"]).agg(
        {'CV': ['median', 'mean']}).reset_index()
    allCVs_summary["ID_Mode"] = "All IDs"
    temp = allCVs[allCVs["ID_Mode"]=="MS2 IDs"].groupby(["Conditions"]).agg(
        {'CV': ['median', 'mean']}).reset_index()
    temp["ID_Mode"] = "MS2 IDs"
    allCVs_summary = pd.concat([temp,allCVs_summary])
    allCVs_summary.columns = ["Conditions", 'meds', 'CoVar',"ID_Mode"]

    
 
    categories = [key for key in saved_settings.keys() if "@" not in key]
    for eachCategory in categories:
        allCVs_summary[eachCategory] = ""
        for eachGroup in group_names:
            allCVs_summary.loc[allCVs_summary["Conditions"]==eachGroup,eachCategory] = saved_settings[eachGroup][eachCategory]


    if plot_options["CV mode"] == "grouped":  
        #find out present categories
        categories = plot_options["color_order"] 
        # create the plot
        fig_data = []
        #display(ID_data)
        i = 0
        for eachCategory in categories:
            fig_data.append(go.Violin(name = str(eachCategory),
                        x=allCVs.loc[allCVs[plot_options["Group By Color"]]==eachCategory,
                        plot_options["Group By X"]].tolist(),
                        y=allCVs.loc[allCVs[plot_options["Group By Color"]]==eachCategory,"CV"].tolist(),
                        fillcolor = plot_options["color"][i],                 
                        box=dict(visible=bool(plot_options["box"]))
                        ))
            i = i + 1
        
                        
        fig = go.Figure(data = fig_data)
        
                        
        fig = go.Figure(data = fig_data)
        
        fig.update_layout(violinmode='group')
        fig.update_xaxes(categoryorder='array', categoryarray = plot_options["x_axis_order"])
    elif plot_options["CV mode"] == "stacked":  
            
        #find out present categories
        layers = allCVs.groupby(plot_options["Group By Stack"]).first().reset_index()[plot_options["Group By Stack"]].tolist()
        # create the plot
        fig_data = []
        #display(ID_data)
        i = 0
        for eachLayer in layers:
            fig_data.append(go.Violin(name = eachLayer,
                        x=allCVs.loc[allCVs[plot_options["Group By Stack"]]==eachLayer,plot_options["Group By X"]].tolist(),
                        y=allCVs.loc[allCVs[plot_options["Group By Stack"]]==eachLayer,"CV"].tolist(),
                        box=dict(visible=bool(plot_options["box"])),
                        fillcolor = plot_options["color"][i]
                        ))
            i = i + 1
        fig = go.Figure(data = fig_data)
        
        fig.update_layout(violinmode='overlay',
                          plot_bgcolor='white',
                          paper_bgcolor='white',
                          yaxis=dict(showline=True, linewidth=1, linecolor='black'),
                          xaxis=dict(showline=True, linewidth=1, linecolor='black')
        )  
        fig.update_xaxes(categoryorder='array', categoryarray = plot_options["x_axis_order"])

    elif plot_options["CV mode"] == "grouped_stacked":
        #make data tidy
        layers = allCVs.groupby(plot_options["Group By Stack"]).first().reset_index()[plot_options["Group By Stack"]].tolist()
        categories = plot_options["color_order"] 
        # Step 1: Calculate median values for each category and layer combination
        medians = allCVs.groupby([plot_options["Group By Color"], plot_options["Group By Stack"]])['CV'].median().reset_index()
        medians.columns = [plot_options["Group By Color"], plot_options["Group By Stack"], 'median']
        #display(medians)

        fig_data = []
        i = 0
        j = 0
        for eachCategory in categories:
            z = 0
            for eachLayer in layers:
                
                fig_data.append(go.Violin(
                    name = str(eachLayer) + " " + str(eachCategory),
                    x = allCVs.loc[(allCVs[plot_options["Group By Color"]]==eachCategory)&(allCVs[plot_options["Group By Stack"]]==eachLayer),plot_options["Group By X"]],
                    y = allCVs.loc[(allCVs[plot_options["Group By Color"]]==eachCategory)&(allCVs[plot_options["Group By Stack"]]==eachLayer),"CV"],
                    box=dict(visible=bool(plot_options["box"])),
                    offsetgroup=i,
                    line_color='black',
                    meanline=dict(visible=False),
                    marker=dict(size=2),
                    width=plot_options["bar_width"],                    
                    fillcolor = plot_options["color"][j]
                    ))
                # Find the corresponding median from the medians DataFrame
                median_value = int(medians.loc[
                    (medians['Conditions'] == eachCategory) &
                    (medians['ID_Mode'] == eachLayer), 'median'].values[0])
                # Add annotation for the median CV
                if z != 0:
                    text_label =f"  {median_value}"
                else:
                    text_label =f"  ({median_value})"
                    
                fig_data.append(go.Scatter(
                    x=allCVs.loc[(allCVs[plot_options["Group By Color"]]==eachCategory)&(allCVs[plot_options["Group By Stack"]]==eachLayer),plot_options["Group By X"]],
                    y=[85+z],  # Adjust the y-position as needed
                    text=text_label,
                    mode="text",
                    showlegend=False,
                    textposition="middle right",
                    textfont = plot_options["font"]
                ))
                z = z + 10


                j = j + 1
            i = i + 1

        fig = go.Figure(
            fig_data,
            layout=go.Layout(
                yaxis=dict(
                    title=dict(
                        text=plot_options["Y Title"],  # Set the title text
                        font=plot_options["font"], 
                        ),
                    range=[0, 100], 
                    showline=True, 
                    linewidth=1, 
                    linecolor='black',
                    tickfont=plot_options["font"]
                    ),
                xaxis=dict(
                    title=dict(
                        text=plot_options["Group By X"],  # Set the title text
                        font=plot_options["font"], 
                        ),
                    showline=True, 
                    linewidth=1, 
                    linecolor='black',
                    tickfont=plot_options["font"]),
                showlegend=plot_options["show Legend"],
                violinmode="group",
                plot_bgcolor='white',
                paper_bgcolor='white',
                
            )
        )
        fig.update_xaxes(categoryorder='array', categoryarray = plot_options["x_axis_order"])
    else:
    # create the interactive plot
        # median label
        if plot_options["median label"] == "True" or \
                plot_options["median label"] == True:
            total_labels = [{"x": x, "y": total*1.15, "text": str(
                round(total,1)), "showarrow": False} for x, total in zip(
                allCVs_summary["Conditions"], allCVs_summary["meds"])]
        else:
            total_labels = []   # no median labels
        fig = px.violin(allCVs,
                        x="Conditions",
                        y='CV',
                        color="Conditions",
                        box=bool(plot_options["box"]),
                        hover_data=["Conditions", 'CV'],
                        color_discrete_sequence=plot_options["color"],
                        width=plot_options["width"],
                        height=plot_options["height"],
                        xlim=plot_options["xlimits"],
                        ylim=plot_options["ylimits"],
                        )

        fig.update_layout(
            yaxis=dict(title=plot_options["Y Title"],
                    range=[0, 100], showline=True, linewidth=1, linecolor='black'),
            font=plot_options["font"],
            xaxis=dict(title=plot_options["X Title"], showline=True, linewidth=1, linecolor='black'),
            showlegend=plot_options["show Legend"],
            width=plot_options["width"],
            height=plot_options["height"],
            annotations=total_labels,
            plot_bgcolor='white',
            paper_bgcolor='white',
            )
        fig.update_xaxes(categoryorder='array', categoryarray = plot_options["x_axis_order"])

    if WRITE_OUTPUT:        
        # create the file for donwnload
        img_dir = os.path.join(APPFOLDER, "images/")
        if not os.path.exists(img_dir):
            Path(img_dir).mkdir(parents=True)

        fig.write_image(os.path.join(
            img_dir, f"{username}_CV_Violin_Plot.svg"), format = "svg", validate = False, engine = "kaleido")
        
        # create the download CSV and its link
        data_dir = os.path.join(APPFOLDER, "csv/")
        if not os.path.exists(data_dir):
            Path(data_dir).mkdir(parents=True)
        allCVs.to_csv(os.path.join(
            data_dir, f"{username}_all_CV.csv"), index=False)
        allCVs_summary.to_csv(os.path.join(
            data_dir, f"{username}_CV_summary.csv"), index=False)
        print("Downloading links...")
        CSV_link = f"/files/{url_base}/csv/" \
            f"{username}_all_CV.csv"

        # download SVG link
        SVG_link = f"/files/{url_base}/images/" \
            f"{username}_CV_Violin_Plot.svg"


    return fig, CSV_link, SVG_link
# ###PCA plots####
def PCA_plots(data_object, plot_options, saved_settings,username=None):
    """_Prepare data for creating intensity PCA plots (two groups)_
    """
    group_names = []

    # no compare groups is provided, compare first two
    for each_key in plot_options["compare groups"]:
        if each_key in plot_options["compare groups"] and saved_settings["Order@Conditions"]:
            group_names.append(each_key)
    # import the data
    group_dict = {}

    # filter runs into different groups
    i = 0
    runname_list = []  # this will contain list of run names list for each groups
    #print(saved_settings)
    for eachGroup in group_names:
        runname_sublist = saved_settings[eachGroup]["records"]
        group_dict[eachGroup] = filter_by_name(
            data_object,
            list(runname_sublist))  # prevent the list from being changed
        runname_list.append(runname_sublist)
        i += 1       
        #print((runname_sublist))

    all_runs =[item for sublist in runname_list for item in sublist]

    # combined the data after filtering
    #  missing values and log2 transformation/normalization
    combined_infodata = pd.DataFrame() # store run names and group names
    combined_pcaData = pd.DataFrame() # store normalized data and protein names
    for eachGroup in group_names:

        current_condition_data = filter_by_missing_values(
            group_dict[eachGroup])
        normalized_data = NormalizeToMedian(
             current_condition_data["protein_abundance"],apply_log2=True)
        toFileDict = dict(zip(data_object["run_metadata"]["Run Identifier"],data_object["run_metadata"]["Run Names"]))
        toFileDict = generate_column_to_name_mapping(normalized_data.columns, toFileDict)
        normalized_data.rename(columns = toFileDict,inplace=True)

        combined_infodata= pd.concat([combined_infodata, pd.DataFrame({
            "Sample_Groups": normalized_data
            .drop(
                "Accession", axis=1).rename(columns = toFileDict).columns,
            "Type": eachGroup})])
        if combined_pcaData.empty:
            combined_pcaData = normalized_data
            print("Empty")
        else:
            combined_pcaData = pd.merge(combined_pcaData, normalized_data)

    #normalize the data
    # using ratio of current group median value divide by the all groups median 
    # to create a scaling factor magicNUm to scale the each group
    quant_names = group_names
    while "Annotated Sequence" in quant_names:
        quant_names.remove("Annotated Sequence")
    while "Accession" in quant_names:
        quant_names.remove("Accession")

    while "Annotated Sequence" in all_runs:
        all_runs.remove("Annotated Sequence")
    while "Accession" in all_runs:
        all_runs.remove("Accession")

    for n in range(len(quant_names)-2): #-2 because not Accession and Annotated Sequence 
        if "Annotated Sequence" in runname_list[n]:
            runname_list[n].remove("Annotated Sequence")
        if "Accession" in runname_list[n]:
            runname_list[n].remove("Accession")
        
        magicNum =np.nanmedian(combined_pcaData[runname_list[
            n]].dropna(how='all').to_numpy()) /\
                np.nanmedian(combined_pcaData[
            all_runs].dropna(how='all').to_numpy()) 
        for col in combined_pcaData[runname_list[
                n]].columns:
            combined_pcaData[col] = combined_pcaData[col]/magicNum


    #performs k-Nearest Neighbors imputation to fill in any missing values
    combined_pcaData = impute_knn(combined_pcaData)
    combined_infodata.reset_index(drop=True, inplace=True)
    

    # perform PCA transform
    combined_pcaData, exp_var_pca = CalculatePCA(combined_pcaData,
                                                     combined_infodata)

    return plot_PCA_plotly(combined_pcaData,
                           exp_var_pca,
                           plot_options=plot_options,
                           username=username,
                           )


def plot_PCA_plotly(pca_panda,
                    exp_var_pca,
                    plot_options=None,
                    username=None,):

    CSV_link = None
    SVG_link = None

    # Assuming pca_data is a pandas dataframe containing PCA results
    # and "Type" is a column in the dataframe indicating the type of sample
    if not plot_options["xlimits"] or plot_options["xlimits"] == "[]" or \
            not isinstance(plot_options["xlimits"], list):
        xlimits = None
    else:
        xlimits = plot_options["xlimits"]

    if not plot_options["ylimits"] or plot_options["ylimits"] == "[]" or \
            not isinstance(plot_options["ylimits"], list):
        ylimits = None
    else:
        ylimits = plot_options["ylimits"]

    fig = px.scatter(pca_panda,
                     x=-1*pca_panda['PC1'],
                     y=-1*pca_panda['PC2'],
                     color="Type",
                     text="Sample_Groups",
                     symbol="Type",
                     color_discrete_sequence=plot_options["color"],

                     symbol_sequence=plot_options["symbol"],
                     size_max=30,
                     labels={
                             'Type': 'Sample Type'}, title='PCA Plot',
                     width=plot_options["width"],
                     height=plot_options["height"],)

    fig.update_traces(
        mode="markers",
        marker=dict(size=plot_options["marker_size"],),
        hovertemplate="%{text}<br>PC1: %{x} <br>PC2: %{y}")
    
    fig.update_layout(
        plot_bgcolor="rgba(255, 255, 255, 255)",
        paper_bgcolor="rgba(255, 255, 255, 255)",
        font=plot_options["font"],
        title=plot_options["title"],
        xaxis=dict(linecolor='black',
                    title= f'PC1 ({round(exp_var_pca[0]*100,2)}%)',
                   showticklabels=False,
                   mirror=True,
                   range=xlimits,
                   showline=True, 
                   linewidth=1,
                   ),
        yaxis=dict(linecolor='black',
                   title=f'PC2 ({round(exp_var_pca[1]*100,2)}%)',
                   showticklabels=False, 
                   mirror=True, 
                   range=ylimits,
                   showline=True, 
                   linewidth=1,
                   ),
    )
    if WRITE_OUTPUT:
        # create the file for donwnload
        img_dir = os.path.join(APPFOLDER, "images/")
        if not os.path.exists(img_dir):
            Path(img_dir).mkdir(parents=True)

        fig.write_image(os.path.join(
            img_dir, f"{username}_PCA_Plot.svg"), format = "svg", validate = False, engine = "kaleido")
        # create the download CSV and its link
        data_dir = os.path.join(APPFOLDER, "csv/")
        if not os.path.exists(data_dir):
            Path(data_dir).mkdir(parents=True)
        pca_panda.to_csv(os.path.join(
            data_dir, f"{username}_PCA.csv"), index=False)
        CSV_link = f"/files/{url_base}/csv/" \
            f"{username}_PCA.csv"

        # download SVG link
        SVG_link = f"/files/{url_base}/images/" \
            f"{username}_PCA_Plot.svg"

    return fig, CSV_link, SVG_link



if __name__ == "__main__":
    pass
    # ID_plots("test", "protein")
    # PCA_plots("test")
